

' VB6/VBA declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter g01
   Declare Sub nag_summary_stats_freq Lib "CLW3226DE_nag.dll" Alias "g01adc" ( _
    ByVal k As long, _
    ByRef x As double, _
    ByRef ifreq As long, _
    ByRef xmean As double, _
    ByRef xsd As double, _
    ByRef xskew As double, _
    ByRef xkurt As double, _
    ByRef n As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_frequency_table Lib "CLW3226DE_nag.dll" Alias "g01aec" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal num_class As long, _
    ByVal classb As Nag_ClassBoundary, _
    ByRef dnint As double, _
    ByRef ifreq As long, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_5pt_summary_stats Lib "CLW3226DE_nag.dll" Alias "g01alc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef res As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_double_quantiles Lib "CLW3226DE_nag.dll" Alias "g01amc" ( _
    ByVal n As long, _
    ByRef rv As double, _
    ByVal nq As long, _
    ByRef q As double, _
    ByRef qv As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_approx_quantiles_fixed Lib "CLW3226DE_nag.dll" Alias "g01anc" ( _
    ByRef ind As long, _
    ByVal n As long, _
    ByRef rv As double, _
    ByVal nb As long, _
    ByVal eps As double, _
    ByRef np As long, _
    ByRef q As double, _
    ByRef qv As double, _
    ByVal nq As long, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_approx_quantiles_arbitrary Lib "CLW3226DE_nag.dll" Alias "g01apc" ( _
    ByRef ind As long, _
    ByRef rv As double, _
    ByVal nb As long, _
    ByVal eps As double, _
    ByRef np As long, _
    ByRef q As double, _
    ByRef qv As double, _
    ByVal nq As long, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_summary_stats_onevar Lib "CLW3226DE_nag.dll" Alias "g01atc" ( _
    ByVal nb As long, _
    ByRef x As double, _
    ByRef wt As double, _
    ByRef pn As long, _
    ByRef xmean As double, _
    ByRef xsd As double, _
    ByRef xskew As double, _
    ByRef xkurt As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_summary_stats_onevar_combine Lib "CLW3226DE_nag.dll" Alias "g01auc" ( _
    ByVal b As long, _
    ByRef mrcomm As double, _
    ByRef pn As long, _
    ByRef xmean As double, _
    ByRef xsd As double, _
    ByRef xskew As double, _
    ByRef xkurt As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_binomial_dist Lib "CLW3226DE_nag.dll" Alias "g01bjc" ( _
    ByVal n As long, _
    ByVal p As double, _
    ByVal k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_poisson_dist Lib "CLW3226DE_nag.dll" Alias "g01bkc" ( _
    ByVal rlamda As double, _
    ByVal k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_hypergeom_dist Lib "CLW3226DE_nag.dll" Alias "g01blc" ( _
    ByVal n As long, _
    ByVal l As long, _
    ByVal m As long, _
    ByVal k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_normal_scores_exact Lib "CLW3226DE_nag.dll" Alias "g01dac" ( _
    ByVal n As long, _
    ByRef pp As double, _
    ByVal etol As double, _
    ByRef errest As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_normal_scores_var Lib "CLW3226DE_nag.dll" Alias "g01dcc" ( _
    ByVal n As long, _
    ByVal exp1 As double, _
    ByVal exp2 As double, _
    ByVal sumssq As double, _
    ByRef vec As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_shapiro_wilk_test Lib "CLW3226DE_nag.dll" Alias "g01ddc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal calc_wts As Nag_Boolean, _
    ByRef a As double, _
    ByRef w As double, _
    ByRef pw As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ranks_and_scores Lib "CLW3226DE_nag.dll" Alias "g01dhc" ( _
    ByVal scores As Nag_Scores, _
    ByVal ties As Nag_Ties, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef r As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_prob_normal Lib "CLW3226DE_nag.dll" Alias "g01eac" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_students_t Lib "CLW3226DE_nag.dll" Alias "g01ebc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal t As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_chi_sq Lib "CLW3226DE_nag.dll" Alias "g01ecc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_f_dist Lib "CLW3226DE_nag.dll" Alias "g01edc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal f As double, _
    ByVal df1 As double, _
    ByVal df2 As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_prob_beta_dist Lib "CLW3226DE_nag.dll" Alias "g01eec" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal tol As double, _
    ByRef p As double, _
    ByRef q As double, _
    ByRef pdf As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_gamma_dist Lib "CLW3226DE_nag.dll" Alias "g01efc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal g As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_studentized_range Lib "CLW3226DE_nag.dll" Alias "g01emc" ( _
    ByVal q As double, _
    ByVal v As double, _
    ByVal ir As long, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_prob_durbin_watson Lib "CLW3226DE_nag.dll" Alias "g01epc" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByVal d As double, _
    ByRef pdl As double, _
    ByRef pdu As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_prob_von_mises Lib "CLW3226DE_nag.dll" Alias "g01erc" ( _
    ByVal t As double, _
    ByVal vk As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_landau Lib "CLW3226DE_nag.dll" Alias "g01etc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_prob_vavilov Lib "CLW3226DE_nag.dll" Alias "g01euc" ( _
    ByVal x As double, _
    ByRef comm_arr As double _
   ) As double

   Declare Function nag_prob_dickey_fuller_unit Lib "CLW3226DE_nag.dll" Alias "g01ewc" ( _
    ByVal method As Nag_TS_URProbMethod, _
    ByVal typ As Nag_TS_URTestType, _
    ByVal n As long, _
    ByVal ts As double, _
    ByVal nsamp As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_1_sample_ks Lib "CLW3226DE_nag.dll" Alias "g01eyc" ( _
    ByVal n As long, _
    ByVal d As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_2_sample_ks Lib "CLW3226DE_nag.dll" Alias "g01ezc" ( _
    ByVal n1 As long, _
    ByVal n2 As long, _
    ByVal d As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_normal Lib "CLW3226DE_nag.dll" Alias "g01fac" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_students_t Lib "CLW3226DE_nag.dll" Alias "g01fbc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_chi_sq Lib "CLW3226DE_nag.dll" Alias "g01fcc" ( _
    ByVal p As double, _
    ByVal df As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_f_dist Lib "CLW3226DE_nag.dll" Alias "g01fdc" ( _
    ByVal p As double, _
    ByVal df1 As double, _
    ByVal df2 As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_beta Lib "CLW3226DE_nag.dll" Alias "g01fec" ( _
    ByVal p As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_gamma_dist Lib "CLW3226DE_nag.dll" Alias "g01ffc" ( _
    ByVal p As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_studentized_range Lib "CLW3226DE_nag.dll" Alias "g01fmc" ( _
    ByVal p As double, _
    ByVal v As double, _
    ByVal ir As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_deviates_landau Lib "CLW3226DE_nag.dll" Alias "g01ftc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_non_central_students_t Lib "CLW3226DE_nag.dll" Alias "g01gbc" ( _
    ByVal t As double, _
    ByVal df As double, _
    ByVal delta As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_non_central_chi_sq Lib "CLW3226DE_nag.dll" Alias "g01gcc" ( _
    ByVal x As double, _
    ByVal df As double, _
    ByVal lambda As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_non_central_f_dist Lib "CLW3226DE_nag.dll" Alias "g01gdc" ( _
    ByVal f As double, _
    ByVal df1 As double, _
    ByVal df2 As double, _
    ByVal lambda As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_prob_non_central_beta_dist Lib "CLW3226DE_nag.dll" Alias "g01gec" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal lambda As double, _
    ByVal tol As double, _
    ByVal max_iter As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bivariate_normal_dist Lib "CLW3226DE_nag.dll" Alias "g01hac" ( _
    ByVal x As double, _
    ByVal y As double, _
    ByVal rho As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_multi_normal Lib "CLW3226DE_nag.dll" Alias "g01hbc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef mean As double, _
    ByRef sigma As double, _
    ByVal tdsig As long, _
    ByVal tol As double, _
    ByVal maxpts As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bivariate_students_t Lib "CLW3226DE_nag.dll" Alias "g01hcc" ( _
    ByVal tail As Nag_TailProbability, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal df As long, _
    ByVal rho As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_multi_students_t Lib "CLW3226DE_nag.dll" Alias "g01hdc" ( _
    ByVal n As long, _
    ByVal tail As Nag_TailProbability, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal nu As double, _
    ByRef delta As double, _
    ByVal iscov As Nag_Boolean, _
    ByRef rc As double, _
    ByVal pdrc As long, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal numsub As long, _
    ByVal nsampl As long, _
    ByVal fmax As long, _
    ByRef errest As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_prob_lin_non_central_chi_sq Lib "CLW3226DE_nag.dll" Alias "g01jcc" ( _
    ByRef a As double, _
    ByRef mult As long, _
    ByRef rlamda As double, _
    ByVal n As long, _
    ByVal c As double, _
    ByRef p As double, _
    ByRef pdf As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_lin_chi_sq Lib "CLW3226DE_nag.dll" Alias "g01jdc" ( _
    ByVal method As Nag_LCCMethod, _
    ByVal n As long, _
    ByRef rlam As double, _
    ByVal d As double, _
    ByVal c As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_normal_pdf Lib "CLW3226DE_nag.dll" Alias "g01kac" ( _
    ByVal x As double, _
    ByVal xmean As double, _
    ByVal xstd As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_gamma_pdf Lib "CLW3226DE_nag.dll" Alias "g01kfc" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_gamma_pdf_vector Lib "CLW3226DE_nag.dll" Alias "g01kkc" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByRef pdf As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_normal_pdf_vector Lib "CLW3226DE_nag.dll" Alias "g01kqc" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal lxmu As long, _
    ByRef xmu As double, _
    ByVal lxstd As long, _
    ByRef xstd As double, _
    ByRef pdf As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_multi_normal_pdf_vector Lib "CLW3226DE_nag.dll" Alias "g01lbc" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal k As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef xmu As double, _
    ByVal iuld As Nag_MatrixType, _
    ByRef sig As double, _
    ByVal pdsig As long, _
    ByRef pdf As double, _
    ByRef rank As long, _
    ByRef fail As NagError _
   )

   Declare Function nag_mills_ratio Lib "CLW3226DE_nag.dll" Alias "g01mbc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_prob_density_landau Lib "CLW3226DE_nag.dll" Alias "g01mtc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_prob_density_vavilov Lib "CLW3226DE_nag.dll" Alias "g01muc" ( _
    ByVal x As double, _
    ByRef comm_arr As double _
   ) As double

   Declare Sub nag_moments_quad_form Lib "CLW3226DE_nag.dll" Alias "g01nac" ( _
    ByVal order as Nag_OrderType, _
    ByVal mom As Nag_SelectMoments, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByRef emu As double, _
    ByRef sigma As double, _
    ByVal pdsig As long, _
    ByVal l As long, _
    ByRef rkum As double, _
    ByRef rmom As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_moments_ratio_quad_forms Lib "CLW3226DE_nag.dll" Alias "g01nbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ratio_type As Nag_MomentType, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef a As double, ByVal pda As long, ByRef b As double, _
    ByVal pdb As long, ByRef c As double, ByVal pdc As long, _
    ByRef ela As double, ByRef emu As double, ByRef sigma As double, _
    ByVal pdsig As long, ByVal l1 As long, ByVal l2 As long, _
    ByRef lmax As long, ByRef rmom As double, ByRef abserr As double, _
    ByVal eps As double, ByRef fail As NagError _
   )

   Declare Function nag_moment_1_landau Lib "CLW3226DE_nag.dll" Alias "g01ptc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_moment_2_landau Lib "CLW3226DE_nag.dll" Alias "g01qtc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_prob_der_landau Lib "CLW3226DE_nag.dll" Alias "g01rtc" ( _
    ByVal x As double _
   ) As double

   Declare Sub nag_prob_normal_vector Lib "CLW3226DE_nag.dll" Alias "g01sac" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal lxmu As long, _
    ByRef xmu As double, _
    ByVal lxstd As long, _
    ByRef xstd As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_students_t_vector Lib "CLW3226DE_nag.dll" Alias "g01sbc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lt As long, _
    ByRef t As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_chi_sq_vector Lib "CLW3226DE_nag.dll" Alias "g01scc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As long, _
    ByRef x As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_f_vector Lib "CLW3226DE_nag.dll" Alias "g01sdc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lf As long, _
    ByRef f As double, _
    ByVal ldf1 As long, _
    ByRef df1 As double, _
    ByVal ldf2 As long, _
    ByRef df2 As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_beta_vector Lib "CLW3226DE_nag.dll" Alias "g01sec" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lbeta As long, _
    ByRef beta As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_gamma_vector Lib "CLW3226DE_nag.dll" Alias "g01sfc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lg As long, _
    ByRef g As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByRef p As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_binomial_vector Lib "CLW3226DE_nag.dll" Alias "g01sjc" ( _
    ByVal ln As long, _
    ByRef n As long, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal lk As long, _
    ByRef k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_poisson_vector Lib "CLW3226DE_nag.dll" Alias "g01skc" ( _
    ByVal ll As long, _
    ByRef l As double, _
    ByVal lk As long, _
    ByRef k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_prob_hypergeom_vector Lib "CLW3226DE_nag.dll" Alias "g01slc" ( _
    ByVal ln As long, _
    ByRef n As long, _
    ByVal ll As long, _
    ByRef l As long, _
    ByVal lm As long, _
    ByRef m As long, _
    ByVal lk As long, _
    ByRef k As long, _
    ByRef plek As double, _
    ByRef pgtk As double, _
    ByRef peqk As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_deviates_normal_vector Lib "CLW3226DE_nag.dll" Alias "g01tac" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal lxmu As long, _
    ByRef xmu As double, _
    ByVal lxstd As long, _
    ByRef xstd As double, _
    ByRef x As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_deviates_students_t_vector Lib "CLW3226DE_nag.dll" Alias "g01tbc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef t As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_deviates_chi_sq_vector Lib "CLW3226DE_nag.dll" Alias "g01tcc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal ldf As long, _
    ByRef df As double, _
    ByRef x As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_deviates_f_vector Lib "CLW3226DE_nag.dll" Alias "g01tdc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal ldf1 As long, _
    ByRef df1 As double, _
    ByVal ldf2 As long, _
    ByRef df2 As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_deviates_beta_vector Lib "CLW3226DE_nag.dll" Alias "g01tec" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByVal tol As double, _
    ByRef beta As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_deviates_gamma_vector Lib "CLW3226DE_nag.dll" Alias "g01tfc" ( _
    ByVal ltail As long, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As long, _
    ByRef p As double, _
    ByVal la As long, _
    ByRef a As double, _
    ByVal lb As long, _
    ByRef b As double, _
    ByVal tol As double, _
    ByRef g As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_moving_average Lib "CLW3226DE_nag.dll" Alias "g01wac" ( _
    ByVal m As long, _
    ByVal nb As long, _
    ByRef x As double, _
    ByVal iwt As Nag_Weightstype, _
    ByRef wt As double, _
    ByRef pn As long, _
    ByRef rmean As double, _
    ByRef rsd As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_init_vavilov Lib "CLW3226DE_nag.dll" Alias "g01zuc" ( _
    ByVal rkappa As double, _
    ByVal beta2 As double, _
    ByVal mode As long, _
    ByRef xl As double, _
    ByRef xu As double, _
    ByRef comm_arr As double, _
    ByRef fail As NagError _
   )


' chapter g02
   Declare Sub nag_nearest_correlation Lib "CLW3226DE_nag.dll" Alias "g02aac" ( _
    ByVal order as Nag_OrderType, _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal errtol As double, _
    ByVal maxits As long, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef feval As long, _
    ByRef nrmgrd As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_nearest_correlation_bounded Lib "CLW3226DE_nag.dll" Alias "g02abc" ( _
    ByVal order as Nag_OrderType, _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal opt As Nag_NearCorr_ProbType, _
    ByVal alpha As double, _
    ByRef w As double, _
    ByVal errtol As double, _
    ByVal maxits As long, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef feval As long, _
    ByRef nrmgrd As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_nearest_correlation_k_factor Lib "CLW3226DE_nag.dll" Alias "g02aec" ( _
    ByVal order as Nag_OrderType, _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal k As long, _
    ByVal errtol As double, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef feval As long, _
    ByRef nrmpgd As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_nearest_correlation_h_weight Lib "CLW3226DE_nag.dll" Alias "g02ajc" ( _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal alpha As double, _
    ByRef h As double, _
    ByVal pdh As long, _
    ByVal errtol As double, _
    ByVal maxit As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef iter As long, _
    ByRef norm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_nearest_correlation_shrinking Lib "CLW3226DE_nag.dll" Alias "g02anc" ( _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal k As long, _
    ByVal errtol As double, _
    ByVal eigtol As double, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef alpha As double, _
    ByRef iter As long, _
    ByRef eigmin As double, _
    ByRef norm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_nearest_correlation_target Lib "CLW3226DE_nag.dll" Alias "g02apc" ( _
    ByRef g As double, _
    ByVal pdg As long, _
    ByVal n As long, _
    ByVal theta As double, _
    ByRef h As double, _
    ByVal pdh As long, _
    ByVal errtol As double, _
    ByVal eigtol As double, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef alpha As double, _
    ByRef iter As long, _
    ByRef eigmin As double, _
    ByRef norm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ken_spe_corr_coeff Lib "CLW3226DE_nag.dll" Alias "g02brc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef svar As long, _
    ByRef sobs As long, _
    ByRef corr As double, _
    ByVal tdc As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_sum_sqs_update Lib "CLW3226DE_nag.dll" Alias "g02btc" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As long, _
    ByVal wt As double, _
    ByRef x As double, _
    ByVal incx As long, _
    ByRef sw As double, _
    ByRef xbar As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_sum_sqs Lib "CLW3226DE_nag.dll" Alias "g02buc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_SumSquare, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef wt As double, _
    ByRef sw As double, _
    ByRef wmean As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_cov_to_corr Lib "CLW3226DE_nag.dll" Alias "g02bwc" ( _
    ByVal m As long, _
    ByRef r As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_corr_cov Lib "CLW3226DE_nag.dll" Alias "g02bxc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef sx As long, _
    ByRef wt As double, _
    ByRef sw As double, _
    ByRef wmean As double, _
    ByRef std As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_partial_corr Lib "CLW3226DE_nag.dll" Alias "g02byc" ( _
    ByVal m As long, _
    ByVal ny As long, _
    ByVal nx As long, _
    ByRef sz As long, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef p As double, _
    ByVal tdp As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_sum_sqs_combine Lib "CLW3226DE_nag.dll" Alias "g02bzc" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As long, _
    ByRef xsw As double, _
    ByRef xmean As double, _
    ByRef xc As double, _
    ByVal ysw As double, _
    ByRef ymean As double, _
    ByRef yc As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_simple_linear_regression Lib "CLW3226DE_nag.dll" Alias "g02cac" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef a_serr As double, _
    ByRef b_serr As double, _
    ByRef rsq As double, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regress_confid_interval Lib "CLW3226DE_nag.dll" Alias "g02cbc" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByVal clm As double, _
    ByVal clp As double, _
    ByRef yhat As double, _
    ByRef yml As double, _
    ByRef ymu As double, _
    ByRef yl As double, _
    ByRef yu As double, _
    ByRef h As double, _
    ByRef res As double, _
    ByRef rms As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear Lib "CLW3226DE_nag.dll" Alias "g02dac" ( _
    ByVal mean As Nag_IncludeMean, ByVal n As long, ByRef x As double, _
    ByVal tdx As long, ByVal m As long, ByRef sx As long, _
    ByVal ip As long, ByRef y As double, ByRef wt As double, _
    ByRef rss As double, ByRef df As double, ByRef b As double, _
    ByRef se As double, ByRef cov As double, ByRef res As double, _
    ByRef h As double, ByRef q As double, ByVal tdq As long, _
    ByRef svd As Nag_Boolean, ByRef rank As long, ByRef p As double, _
    ByVal tol As double, ByRef com_ar As double, ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_addrem_obs Lib "CLW3226DE_nag.dll" Alias "g02dcc" ( _
    ByVal update As Nag_UpdateObserv, _
    ByVal mean As Nag_IncludeMean, _
    ByVal m As long, _
    ByRef sx As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByVal ip As long, _
    ByRef x As double, _
    ByVal nr As long, _
    ByVal tdx As long, _
    ByVal ix As long, _
    ByVal y As double, _
    ByRef wt As double, _
    ByRef rss As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_upd_model Lib "CLW3226DE_nag.dll" Alias "g02ddc" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef b As double, _
    ByRef se As double, _
    ByRef cov As double, _
    ByRef svd As Nag_Boolean, _
    ByRef rank As long, _
    ByRef p As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_add_var Lib "CLW3226DE_nag.dll" Alias "g02dec" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByRef p As double, _
    ByRef wt As double, _
    ByRef x As double, _
    ByRef rss As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_delete_var Lib "CLW3226DE_nag.dll" Alias "g02dfc" ( _
    ByVal ip As long, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByVal indx As long, _
    ByRef rss As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_newyvar Lib "CLW3226DE_nag.dll" Alias "g02dgc" ( _
    ByVal n As long, _
    ByRef wt As double, _
    ByRef rss As double, _
    ByVal ip As long, _
    ByVal rank As long, _
    ByRef cov As double, _
    ByRef q As double, _
    ByVal tdq As long, _
    ByVal svd As Nag_Boolean, _
    ByRef p As double, _
    ByRef y As double, _
    ByRef b As double, _
    ByRef se As double, _
    ByRef res As double, _
    ByRef com_ar As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_tran_model Lib "CLW3226DE_nag.dll" Alias "g02dkc" ( _
    ByVal ip As long, _
    ByVal iconst As long, _
    ByRef p As double, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef b As double, _
    ByVal rss As double, _
    ByVal df As double, _
    ByRef se As double, _
    ByRef cov As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_mult_linear_est_func Lib "CLW3226DE_nag.dll" Alias "g02dnc" ( _
    ByVal ip As long, _
    ByVal rank As long, _
    ByRef b As double, _
    ByRef cov As double, _
    ByRef p As double, _
    ByRef f As double, _
    ByRef est As Nag_Boolean, _
    ByRef stat As double, _
    ByRef sestat As double, _
    ByRef t As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_all_regsn Lib "CLW3226DE_nag.dll" Alias "g02eac" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef var_names As Long, _
    ByRef sx As long, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef nmod As long, _
    ByRef model As Long, _
    ByRef rss As double, _
    ByRef nterms As long, _
    ByRef mrank As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_cp_stat Lib "CLW3226DE_nag.dll" Alias "g02ecc" ( _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As long, _
    ByVal sigsq As double, _
    ByVal tss As double, _
    ByVal nmod As long, _
    ByRef nterms As long, _
    ByRef rss As double, _
    ByRef rsq As double, _
    ByRef cp As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_step_regsn Lib "CLW3226DE_nag.dll" Alias "g02eec" ( _
    ByVal order as Nag_OrderType, _
    ByRef istep As long, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByVal m As long, ByRef x As double, ByVal pdx As long, _
    ByRef var_names As Long, ByRef sx As long, ByVal maxip As long, _
    ByRef y As double, ByRef wt As double, ByVal fin As double, _
    ByRef addvar As Nag_Boolean, ByRef newvar As Long, ByRef chrss As double, _
    ByRef f As double, ByRef model As Long, ByRef nterm As long, _
    ByRef rss As double, ByRef idf As long, ByRef ifr As long, _
    ByRef free_vars As Long, ByRef exss As double, ByRef q As double, _
    ByVal pdq As long, ByRef p As double, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_full_step_regsn_monfun( _
'      ByVal flag As Nag_FullStepwise, _
'      ByVal var As long, _
'      ByVal val As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_full_step_regsn Lib "CLW3226DE_nag.dll" Alias "g02efc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef wmean As double, _
    ByRef c As double, _
    ByVal sw As double, _
    ByRef isx As long, _
    ByVal fin As double, _
    ByVal fout As double, _
    ByVal tau As double, _
    ByRef b As double, _
    ByRef se As double, _
    ByRef rsq As double, _
    ByRef rms As double, _
    ByRef df As long, _
    ByVal monfun As Long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_std_resid_influence Lib "CLW3226DE_nag.dll" Alias "g02fac" ( _
    ByVal n As long, _
    ByVal ip As long, _
    ByVal nres As long, _
    ByRef res As double, _
    ByRef h As double, _
    ByVal rms As double, _
    ByRef sres As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_durbin_watson_stat Lib "CLW3226DE_nag.dll" Alias "g02fcc" ( _
    ByVal n As long, _
    ByVal p As long, _
    ByRef res As double, _
    ByRef d As double, _
    ByRef pdl As double, _
    ByRef pdu As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_glm_normal Lib "CLW3226DE_nag.dll" Alias "g02gac" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef wt As double, ByRef offset As double, ByRef dnscale As double, _
    ByVal ex_power As double, ByRef rss As double, ByRef df As double, _
    ByRef b As double, ByRef rank As long, ByRef se As double, _
    ByRef cov As double, ByRef v As double, ByVal tdv As long, _
    ByVal tol As double, ByVal max_iter As long, ByVal print_iter As long, _
    ByVal outfile As String, ByVal eps As double, ByRef fail As NagError _
   )

   Declare Sub nag_glm_binomial Lib "CLW3226DE_nag.dll" Alias "g02gbc" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef binom_t As double, ByRef wt As double, ByRef offset As double, _
    ByRef dev As double, ByRef df As double, ByRef b As double, _
    ByRef rank As long, ByRef se As double, ByRef cov As double, _
    ByRef v As double, ByVal tdv As long, ByVal tol As double, _
    ByVal max_iter As long, ByVal print_iter As long, ByVal outfile As String, _
    ByVal eps As double, ByRef fail As NagError _
   )

   Declare Sub nag_glm_poisson Lib "CLW3226DE_nag.dll" Alias "g02gcc" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef wt As double, ByRef offset As double, ByVal ex_power As double, _
    ByRef dev As double, ByRef df As double, ByRef b As double, _
    ByRef rank As long, ByRef se As double, ByRef cov As double, _
    ByRef v As double, ByVal tdv As long, ByVal tol As double, _
    ByVal max_iter As long, ByVal print_iter As long, ByVal outfile As String, _
    ByVal eps As double, ByRef fail As NagError _
   )

   Declare Sub nag_glm_gamma Lib "CLW3226DE_nag.dll" Alias "g02gdc" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As long, _
    ByRef x As double, ByVal tdx As long, ByVal m As long, _
    ByRef sx As long, ByVal ip As long, ByRef y As double, _
    ByRef wt As double, ByRef offset As double, ByRef dnscale As double, _
    ByVal ex_power As double, ByRef dev As double, ByRef df As double, _
    ByRef b As double, ByRef rank As long, ByRef se As double, _
    ByRef cov As double, ByRef v As double, ByVal tdv As long, _
    ByVal tol As double, ByVal max_iter As long, ByVal print_iter As long, _
    ByVal outfile As String, ByVal eps As double, ByRef fail As NagError _
   )

   Declare Sub nag_glm_tran_model Lib "CLW3226DE_nag.dll" Alias "g02gkc" ( _
    ByVal ip As long, _
    ByVal nclin As long, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef b As double, _
    ByVal dnscale As double, _
    ByRef se As double, _
    ByRef cov As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_glm_est_func Lib "CLW3226DE_nag.dll" Alias "g02gnc" ( _
    ByVal ip As long, _
    ByVal rank As long, _
    ByRef b As double, _
    ByRef cov As double, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef f As double, _
    ByRef est As Nag_Boolean, _
    ByRef stat As double, _
    ByRef sestat As double, _
    ByRef z As double, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_glm_predict Lib "CLW3226DE_nag.dll" Alias "g02gpc" ( _
    ByVal errfn As Nag_Distributions, ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, _
    ByVal n As long, ByRef x As double, ByVal tdx As long, _
    ByVal m As long, ByRef sx As long, ByVal ip As long, _
    ByRef binom_t As double, ByRef offset As double, ByRef wt As double, _
    ByVal dnscale As double, ByVal ex_power As double, ByRef b As double, _
    ByRef cov As double, ByVal vfobs As Nag_Boolean, ByRef eta As double, _
    ByRef seeta As double, ByRef pred As double, ByRef sepred As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_robust_m_regsn_estim Lib "CLW3226DE_nag.dll" Alias "g02hac" ( _
    ByVal regtype As Nag_RegType, ByVal psifun As Nag_PsiFun, ByVal sigma_est As Nag_SigmaEst, _
    ByVal covmat_est As Nag_CovMatrixEst, ByVal n As long, ByVal m As long, _
    ByRef x As double, ByVal tdx As long, ByRef y As double, _
    ByVal cpsi As double, ByRef hpsi As double, ByVal cucv As double, _
    ByVal dchi As double, ByRef theta As double, ByRef sigma As double, _
    ByRef c As double, ByVal tdc As long, ByRef rs As double, _
    ByRef wt As double, ByVal tol As double, ByVal max_iter As long, _
    ByVal print_iter As long, ByVal outfile As String, ByRef info As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_robust_m_regsn_wts_ucv( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_robust_m_regsn_wts Lib "CLW3226DE_nag.dll" Alias "g02hbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As Long, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef a As double, _
    ByRef z As double, _
    ByVal bl As double, _
    ByVal bd As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByVal nitmon As long, _
    ByVal outfile As String, _
    ByRef nit As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_robust_m_regsn_user_fn_chi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_robust_m_regsn_user_fn_psi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_robust_m_regsn_user_fn Lib "CLW3226DE_nag.dll" Alias "g02hdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal chi As Long, _
    ByVal psi As Long, _
    ByVal psip0 As double, _
    ByVal beta As double, ByVal regtype As Nag_RegType, ByVal sigma_est As Nag_SigmaEst, _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef y As double, ByRef wgt As double, _
    ByRef theta As double, ByRef k As long, ByRef sigma As double, _
    ByRef rs As double, ByVal tol As double, ByVal eps As double, _
    ByVal maxit As long, ByVal nitmon As long, ByVal outfile As String, _
    ByRef nit As long, ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_robust_m_regsn_param_var_psi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_robust_m_regsn_param_var_psp( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_robust_m_regsn_param_var Lib "CLW3226DE_nag.dll" Alias "g02hfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal psi As Long, _
    ByVal psp As Long, _
    ByVal regtype As Nag_RegType, _
    ByVal covmat_est As Nag_CovMatrixEst, _
    ByVal sigma As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef rs As double, _
    ByRef wgt As double, _
    ByRef cov As double, _
    ByVal pdc As long, _
    ByRef comm_arr As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_robust_corr_estim Lib "CLW3226DE_nag.dll" Alias "g02hkc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByVal eps As double, _
    ByRef cov As double, _
    ByRef theta As double, _
    ByVal max_iter As long, _
    ByVal print_iter As long, _
    ByVal outfile As String, _
    ByVal tol As double, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_robust_m_corr_user_fn_ucv( _
'      ByVal t As double, _
'      ByRef u As double, _
'      ByRef ud As double, _
'      ByRef w As double, _
'      ByRef wd As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_robust_m_corr_user_fn Lib "CLW3226DE_nag.dll" Alias "g02hlc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As Long, _
    ByVal indm As long, ByVal n As long, _
    ByVal m As long, ByRef x As double, ByVal pdx As long, _
    ByRef cov As double, ByRef a As double, ByRef wt As double, _
    ByRef theta As double, ByVal bl As double, ByVal bd As double, _
    ByVal maxit As long, ByVal nitmon As long, ByVal outfile As String, _
    ByVal tol As double, ByRef nit As long, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_robust_m_corr_user_fn_no_derr_ucv( _
'      ByVal t As double, _
'      ByRef u As double, _
'      ByRef w As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_robust_m_corr_user_fn_no_derr Lib "CLW3226DE_nag.dll" Alias "g02hmc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As Long, _
    ByVal indm As long, ByVal n As long, _
    ByVal m As long, ByRef x As double, ByVal pdx As long, _
    ByRef cov As double, ByRef a As double, ByRef wt As double, _
    ByRef theta As double, ByVal bl As double, ByVal bd As double, _
    ByVal maxit As long, ByVal nitmon As long, ByVal outfile As String, _
    ByVal tol As double, ByRef nit As long, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Sub nag_reml_mixed_regsn Lib "CLW3226DE_nag.dll" Alias "g02jac" ( _
    ByVal n As long, ByVal ncol As long, ByRef dat As double, _
    ByVal tddat As long, ByRef levels As long, ByVal yvid As long, _
    ByVal cwid As long, ByVal nfv As long, ByRef fvid As long, _
    ByVal fint As long, ByVal nrv As long, ByRef rvid As long, _
    ByVal nvpr As long, ByRef vpr As long, ByVal rint As long, _
    ByVal svid As long, ByRef gamma As double, ByRef nff As long, _
    ByRef nrf As long, ByRef df As long, ByRef reml As double, _
    ByVal lb As long, ByRef b As double, ByRef se As double, _
    ByVal maxit As long, ByVal tol As double, ByRef warn As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_ml_mixed_regsn Lib "CLW3226DE_nag.dll" Alias "g02jbc" ( _
    ByVal n As long, ByVal ncol As long, ByRef dat As double, _
    ByVal tddat As long, ByRef levels As long, ByVal yvid As long, _
    ByVal cwid As long, ByVal nfv As long, ByRef fvid As long, _
    ByVal fint As long, ByVal nrv As long, ByRef rvid As long, _
    ByVal nvpr As long, ByRef vpr As long, ByVal rint As long, _
    ByVal svid As long, ByRef gamma As double, ByRef nff As long, _
    ByRef nrf As long, ByRef df As long, ByRef ml As double, _
    ByVal lb As long, ByRef b As double, ByRef se As double, _
    ByVal maxit As long, ByVal tol As double, ByRef warn As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_hier_mixed_init Lib "CLW3226DE_nag.dll" Alias "g02jcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal ncol As long, ByRef dat As double, _
    ByVal pddat As long, ByRef levels As long, ByRef y As double, _
    ByRef wt As double, ByRef dnfixed As long, ByVal lfixed As long, _
    ByVal nrndm As long, ByRef rndm As long, ByVal lrndm As long, _
    ByRef nff As long, ByRef nlsv As long, ByRef nrf As long, _
    ByRef rcomm As double, ByVal lrcomm As long, ByRef icomm As long, _
    ByVal licomm As long, ByRef fail As NagError _
   )

   Declare Sub nag_reml_hier_mixed_regsn Lib "CLW3226DE_nag.dll" Alias "g02jdc" ( _
    ByVal lvpr As long, ByRef vpr As long, ByVal nvpr As long, _
    ByRef gamma As double, ByRef effn As long, ByRef rnkx As long, _
    ByRef ncov As long, ByRef lnlike As double, ByVal lb As long, _
    ByRef id As long, ByVal pdid As long, ByRef b As double, _
    ByRef se As double, ByRef czz As double, ByVal pdczz As long, _
    ByRef cxx As double, ByVal pdcxx As long, ByRef cxz As double, _
    ByVal pdcxz As long, ByRef rcomm As double, ByRef icomm As long, _
    ByRef iopt As long, ByVal liopt As long, ByRef ropt As double, _
    ByVal lropt As long, ByRef fail As NagError _
   )

   Declare Sub nag_ml_hier_mixed_regsn Lib "CLW3226DE_nag.dll" Alias "g02jec" ( _
    ByVal lvpr As long, ByRef vpr As long, ByVal nvpr As long, _
    ByRef gamma As double, ByRef effn As long, ByRef rnkx As long, _
    ByRef ncov As long, ByRef lnlike As double, ByVal lb As long, _
    ByRef id As long, ByVal pdid As long, ByRef b As double, _
    ByRef se As double, ByRef czz As double, ByVal pdczz As long, _
    ByRef cxx As double, ByVal pdcxx As long, ByRef cxz As double, _
    ByVal pdcxz As long, ByRef rcomm As double, ByRef icomm As long, _
    ByRef iopt As long, ByVal liopt As long, ByRef ropt As double, _
    ByVal lropt As long, ByRef fail As NagError _
   )

   Declare Sub nag_regsn_ridge_opt Lib "CLW3226DE_nag.dll" Alias "g02kac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByVal tau As double, ByRef y As double, ByRef h As double, _
    ByVal opt As Nag_PredictError, ByRef niter As long, ByVal tol As double, _
    ByRef nep As double, ByVal orig As Nag_EstimatesOption, ByRef b As double, _
    ByRef vif As double, ByRef res As double, ByRef rss As double, _
    ByRef df As long, ByVal optloo As Nag_OptionLOO, ByRef perr As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_ridge Lib "CLW3226DE_nag.dll" Alias "g02kbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByRef y As double, ByVal lh As long, ByRef h As double, _
    ByRef nep As double, ByVal wantb As Nag_ParaOption, ByRef b As double, _
    ByVal pdb As long, ByVal wantvf As Nag_VIFOption, ByRef vf As double, _
    ByVal pdvf As long, ByVal lpec As long, ByVal pec As Nag_PredictError, _
    ByRef pe As double, ByVal pdpe As long, ByRef fail As NagError _
   )

   Declare Sub nag_pls_orth_scores_svd Lib "CLW3226DE_nag.dll" Alias "g02lac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal mx As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByVal my As long, ByRef y As double, ByVal pdy As long, _
    ByRef xbar As double, ByRef ybar As double, ByVal iscale As Nag_ScalePredictor, _
    ByRef xstd As double, ByRef ystd As double, ByVal maxfac As long, _
    ByRef xres As double, ByVal pdxres As long, ByRef yres As double, _
    ByVal pdyres As long, ByRef w As double, ByVal pdw As long, _
    ByRef p As double, ByVal pdp As long, ByRef t As double, _
    ByVal pdt As long, ByRef c As double, ByVal pdc As long, _
    ByRef u As double, ByVal pdu As long, ByRef xcv As double, _
    ByRef ycv As double, ByVal pdycv As long, ByRef fail As NagError _
   )

   Declare Sub nag_pls_orth_scores_wold Lib "CLW3226DE_nag.dll" Alias "g02lbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal mx As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal ip As long, _
    ByVal my As long, ByRef y As double, ByVal pdy As long, _
    ByRef xbar As double, ByRef ybar As double, ByVal iscale As Nag_ScalePredictor, _
    ByRef xstd As double, ByRef ystd As double, ByVal maxfac As long, _
    ByVal maxit As long, ByVal tau As double, ByRef xres As double, _
    ByVal pdxres As long, ByRef yres As double, ByVal pdyres As long, _
    ByRef w As double, ByVal pdw As long, ByRef p As double, _
    ByVal pdp As long, ByRef t As double, ByVal pdt As long, _
    ByRef c As double, ByVal pdc As long, ByRef u As double, _
    ByVal pdu As long, ByRef xcv As double, ByRef ycv As double, _
    ByVal pdycv As long, ByRef fail As NagError _
   )

   Declare Sub nag_pls_orth_scores_fit Lib "CLW3226DE_nag.dll" Alias "g02lcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As long, ByVal my As long, ByVal maxfac As long, _
    ByVal nfact As long, ByRef p As double, ByVal pdp As long, _
    ByRef c As double, ByVal pdc As long, ByRef w As double, _
    ByVal pdw As long, ByVal rcond As double, ByRef b As double, _
    ByVal pdb As long, ByVal orig As Nag_EstimatesOption, ByRef xbar As double, _
    ByRef ybar As double, ByVal iscale As Nag_ScalePredictor, ByRef xstd As double, _
    ByRef ystd As double, ByRef ob As double, ByVal pdob As long, _
    ByVal vipopt As long, ByRef ycv As double, ByVal pdycv As long, _
    ByRef vip As double, ByVal pdvip As long, ByRef fail As NagError _
   )

   Declare Sub nag_pls_orth_scores_pred Lib "CLW3226DE_nag.dll" Alias "g02ldc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As long, _
    ByVal my As long, _
    ByVal orig As Nag_EstimatesOption, _
    ByRef xbar As double, _
    ByRef ybar As double, _
    ByVal iscale As Nag_ScalePredictor, _
    ByRef xstd As double, _
    ByRef ystd As double, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByVal n As long, _
    ByVal mz As long, _
    ByRef isz As long, _
    ByRef z As double, _
    ByVal pdz As long, _
    ByRef yhat As double, _
    ByVal pdyhat As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_lars Lib "CLW3226DE_nag.dll" Alias "g02mac" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal prey As Nag_LARSPreProcess, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef d As double, _
    ByVal pdd As long, _
    ByRef isx As long, _
    ByRef y As double, _
    ByVal mnstep As long, _
    ByRef ip As long, _
    ByRef nstep As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef fitsum As double, _
    ByRef ropt As double, _
    ByVal lropt As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_lars_xtx Lib "CLW3226DE_nag.dll" Alias "g02mbc" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal intcpt As Nag_LARSPreProcess, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef dtd As double, _
    ByVal pddtd As long, _
    ByRef isx As long, _
    ByRef dty As double, _
    ByVal yty As double, _
    ByVal mnstep As long, _
    ByRef ip As long, _
    ByRef nstep As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef fitsum As double, _
    ByRef ropt As double, _
    ByVal lropt As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_lars_param Lib "CLW3226DE_nag.dll" Alias "g02mcc" ( _
    ByVal nstep As long, _
    ByVal ip As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef fitsum As double, _
    ByVal ktype As Nag_LARSTargetType, _
    ByRef nk As double, _
    ByVal lnk As long, _
    ByRef nb As double, _
    ByVal pdnb As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_quant_linear_iid Lib "CLW3226DE_nag.dll" Alias "g02qfc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal ntau As long, _
    ByRef tau As double, _
    ByRef df As double, _
    ByRef b As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef info As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_regsn_quant_linear Lib "CLW3226DE_nag.dll" Alias "g02qgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal intcpt As Nag_IncludeIntercept, ByVal n As long, ByVal m As long, _
    ByRef dat As double, ByVal pddat As long, ByRef isx As long, _
    ByVal ip As long, ByRef y As double, ByRef wt As double, _
    ByVal ntau As long, ByRef tau As double, ByRef df As double, _
    ByRef b As double, ByRef bl As double, ByRef bu As double, _
    ByRef ch As double, ByRef res As double, ByRef iopts As long, _
    ByRef opts As double, ByRef state As long, ByRef info As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_g02_opt_set Lib "CLW3226DE_nag.dll" Alias "g02zkc" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_g02_opt_get Lib "CLW3226DE_nag.dll" Alias "g02zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' chapter g03
   Declare Sub nag_mv_prin_comp Lib "CLW3226DE_nag.dll" Alias "g03aac" ( _
    ByVal pcmatrix As Nag_PrinCompMat, _
    ByVal scores As Nag_PrinCompScores, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByRef s As double, _
    ByRef wt As double, _
    ByVal nvar As long, _
    ByRef e As double, _
    ByVal tde As long, _
    ByRef p As double, _
    ByVal tdp As long, _
    ByRef v As double, _
    ByVal tdv As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_canon_var Lib "CLW3226DE_nag.dll" Alias "g03acc" ( _
    ByVal weight As Nag_Weightstype, ByVal n As long, ByVal m As long, _
    ByRef x As double, ByVal tdx As long, ByRef isx As long, _
    ByVal nx As long, ByRef ing As long, ByVal ng As long, _
    ByRef wt As double, ByRef nig As long, ByRef cvm As double, _
    ByVal tdcvm As long, ByRef e As double, ByVal tde As long, _
    ByRef ncv As long, ByRef cvx As double, ByVal tdcvx As long, _
    ByVal tol As double, ByRef irankx As long, ByRef fail As NagError _
   )

   Declare Sub nag_mv_canon_corr Lib "CLW3226DE_nag.dll" Alias "g03adc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef z As double, _
    ByVal tdz As long, _
    ByRef isz As long, _
    ByVal nx As long, _
    ByVal ny As long, _
    ByRef wt As double, _
    ByRef e As double, _
    ByVal tde As long, _
    ByRef ncv As long, _
    ByRef cvx As double, _
    ByVal tdcvx As long, _
    ByRef cvy As double, _
    ByVal tdcvy As long, _
    ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_orthomax Lib "CLW3226DE_nag.dll" Alias "g03bac" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal g As double, _
    ByVal nvar As long, _
    ByVal k As long, _
    ByRef fl As double, _
    ByVal tdf As long, _
    ByRef flr As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByVal acc As double, _
    ByVal maxit As long, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_procustes Lib "CLW3226DE_nag.dll" Alias "g03bcc" ( _
    ByVal stand As Nag_TransNorm, _
    ByVal pscale As Nag_RotationScale, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef y As double, _
    ByVal tdy As long, _
    ByRef yhat As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef alpha As double, _
    ByRef rss As double, _
    ByRef res As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_promax Lib "CLW3226DE_nag.dll" Alias "g03bdc" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef ro As double, _
    ByVal pdro As long, _
    ByVal power As double, _
    ByRef fp As double, _
    ByVal pdfp As long, _
    ByRef r As double, _
    ByVal pdr As long, _
    ByRef phi As double, _
    ByVal pdphi As long, _
    ByRef fs As double, _
    ByVal pdfs As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_factor Lib "CLW3226DE_nag.dll" Alias "g03cac" ( _
    ByVal matrix As Nag_FacMat, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByVal nvar As long, _
    ByRef isx As long, _
    ByVal nfac As long, _
    ByRef wt As double, _
    ByRef e As double, _
    ByRef stat As double, _
    ByRef com As double, _
    ByRef psi As double, _
    ByRef res As double, _
    ByRef fl As double, _
    ByVal tdfl As long, _
    ByRef ops As Nag_E04_Opt, _
    ByVal eps As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_fac_score Lib "CLW3226DE_nag.dll" Alias "g03ccc" ( _
    ByVal method As Nag_FacScoreMethod, _
    ByVal rotate As Nag_FacRotation, _
    ByVal nvar As long, _
    ByVal nfac As long, _
    ByRef fl As double, _
    ByVal tdfl As long, _
    ByRef psi As double, _
    ByRef e As double, _
    ByRef r As double, _
    ByVal tdr As long, _
    ByRef fs As double, _
    ByVal tdfs As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_discrim Lib "CLW3226DE_nag.dll" Alias "g03dac" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByVal nvar As long, _
    ByRef ing As long, _
    ByVal ng As long, _
    ByRef wt As double, _
    ByRef nig As long, _
    ByRef gmean As double, _
    ByVal tdg As long, _
    ByRef det As double, _
    ByRef gc As double, _
    ByRef stat As double, _
    ByRef df As double, _
    ByRef sig As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_discrim_mahaldist Lib "CLW3226DE_nag.dll" Alias "g03dbc" ( _
    ByVal equal As Nag_GroupCovars, _
    ByVal mode As Nag_MahalDist, _
    ByVal nvar As long, _
    ByVal ng As long, _
    ByRef gmean As double, _
    ByVal tdg As long, _
    ByRef gc As double, _
    ByVal nobs As long, _
    ByVal m As long, _
    ByRef isx As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef d As double, _
    ByVal tdd As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_discrim_group Lib "CLW3226DE_nag.dll" Alias "g03dcc" ( _
    ByVal typ As Nag_DiscrimMethod, ByVal equal As Nag_GroupCovars, ByVal priors As Nag_PriorProbability, _
    ByVal nvar As long, ByVal ng As long, ByRef nig As long, _
    ByRef gmean As double, ByVal tdg As long, ByRef gc As double, _
    ByRef det As double, ByVal nobs As long, ByVal m As long, _
    ByRef isx As long, ByRef x As double, ByVal tdx As long, _
    ByRef prior As double, ByRef p As double, ByVal tdp As long, _
    ByRef iag As long, ByVal atiq As Nag_Boolean, ByRef ati As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_distance_mat Lib "CLW3226DE_nag.dll" Alias "g03eac" ( _
    ByVal update As Nag_MatUpdate, _
    ByVal dist As Nag_DistanceType, _
    ByVal dnscale As Nag_VarScaleType, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByRef s As double, _
    ByRef d As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_hierar_cluster_analysis Lib "CLW3226DE_nag.dll" Alias "g03ecc" ( _
    ByVal method As Nag_ClusterMethod, _
    ByVal n As long, _
    ByRef d As double, _
    ByRef ilc As long, _
    ByRef iuc As long, _
    ByRef cd As double, _
    ByRef iord As long, _
    ByRef dord As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_kmeans_cluster_analysis Lib "CLW3226DE_nag.dll" Alias "g03efc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef isx As long, _
    ByVal nvar As long, _
    ByVal k As long, _
    ByRef cmeans As double, _
    ByVal tdc As long, _
    ByRef wt As double, _
    ByRef inc As long, _
    ByRef nic As long, _
    ByRef css As double, _
    ByRef csw As double, _
    ByVal maxit As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_dendrogram Lib "CLW3226DE_nag.dll" Alias "g03ehc" ( _
    ByVal orient As Nag_DendOrient, _
    ByVal n As long, _
    ByRef dord As double, _
    ByVal dmin As double, _
    ByVal dstep As double, _
    ByVal nsym As long, _
    ByVal c As String, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_cluster_indicator Lib "CLW3226DE_nag.dll" Alias "g03ejc" ( _
    ByVal n As long, _
    ByRef cd As double, _
    ByRef iord As long, _
    ByRef dord As double, _
    ByRef k As long, _
    ByRef dlevel As double, _
    ByRef ic As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_prin_coord_analysis Lib "CLW3226DE_nag.dll" Alias "g03fac" ( _
    ByVal roots As Nag_Eigenvalues, _
    ByVal n As long, _
    ByRef d As double, _
    ByVal ndim As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef eval As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_ordinal_multidimscale Lib "CLW3226DE_nag.dll" Alias "g03fcc" ( _
    ByVal typ As Nag_ScaleCriterion, _
    ByVal n As long, _
    ByVal ndim As long, _
    ByRef d As double, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef stress As double, _
    ByRef dfit As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mv_gaussian_mixture Lib "CLW3226DE_nag.dll" Alias "g03gac" ( _
    ByVal n As long, ByVal m As long, ByRef x As double, _
    ByVal pdx As long, ByRef isx As long, ByVal nvar As long, _
    ByVal ng As long, ByVal popt As Nag_Boolean, ByRef prob As double, _
    ByVal tdprob As long, ByRef niter As long, ByVal riter As long, _
    ByRef w As double, ByRef g As double, ByVal sopt As Nag_VarCovar, _
    ByRef s As double, ByRef f As double, ByVal tol As double, _
    ByRef loglik As double, ByRef fail As NagError _
   )

   Declare Sub nag_mv_dend_free Lib "CLW3226DE_nag.dll" Alias "g03xzc" ( _
    ByVal c As String _
   )

   Declare Sub nag_mv_z_scores Lib "CLW3226DE_nag.dll" Alias "g03zac" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByVal nvar As long, _
    ByRef isx As long, _
    ByRef s As double, _
    ByRef e As double, _
    ByRef z As double, _
    ByVal tdz As long, _
    ByRef fail As NagError _
   )


' chapter g04
   Declare Sub nag_anova_random Lib "CLW3226DE_nag.dll" Alias "g04bbc" ( _
    ByVal n As long, _
    ByRef y As double, _
    ByVal blocks As Nag_Blocks, _
    ByVal iblock As long, _
    ByVal nt As long, _
    ByRef it As long, _
    ByRef gmean As double, _
    ByRef bmean As double, _
    ByRef tmean As double, _
    ByRef table As double, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef irep As long, _
    ByRef r As double, _
    ByRef ef As double, _
    ByVal tol As double, _
    ByVal irdf As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_anova_row_col Lib "CLW3226DE_nag.dll" Alias "g04bcc" ( _
    ByVal nrep As long, ByVal nrow As long, ByVal ncol As long, _
    ByRef y As double, ByVal nt As long, ByRef it As long, _
    ByRef gmean As double, ByRef tmean As double, ByRef table As double, _
    ByRef c As double, ByVal tdc As long, ByRef irep As long, _
    ByRef rpmean As double, ByRef rmean As double, ByRef cmean As double, _
    ByRef r As double, ByRef ef As double, ByVal tol As double, _
    ByVal irdf As long, ByRef fail As NagError _
   )

   Declare Sub nag_anova_factorial Lib "CLW3226DE_nag.dll" Alias "g04cac" ( _
    ByVal n As long, _
    ByRef y As double, _
    ByVal nfac As long, _
    ByRef lfac As long, _
    ByVal nblock As long, _
    ByVal inter As long, _
    ByVal irdf As long, _
    ByRef mterm As long, _
    ByRef tableptr As Long, _
    ByRef tmeanptr As Long, _
    ByRef maxt As long, _
    ByRef eptr As Long, _
    ByRef imeanptr As Long, _
    ByRef semeanptr As Long, _
    ByRef bmeanptr As Long, _
    ByRef r As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_anova_factorial_free Lib "CLW3226DE_nag.dll" Alias "g04czc" ( _
    ByRef tableptr As Long, _
    ByRef tmeanptr As Long, _
    ByRef eptr As Long, _
    ByRef imeanptr As Long, _
    ByRef semeanptr As Long, _
    ByRef bmeanptr As Long _
   )

   Declare Sub nag_anova_confid_interval Lib "CLW3226DE_nag.dll" Alias "g04dbc" ( _
    ByVal typ As Nag_IntervalType, _
    ByVal nt As long, _
    ByRef tmean As double, _
    ByVal rdf As double, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByVal clevel As double, _
    ByRef cil As double, _
    ByRef ciu As double, _
    ByRef isig As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_dummy_vars Lib "CLW3226DE_nag.dll" Alias "g04eac" ( _
    ByVal typ As Nag_DummyType, _
    ByVal n As long, _
    ByVal levels As long, _
    ByRef factor As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef v As double, _
    ByRef num_reps As double, _
    ByRef fail As NagError _
   )


' chapter g05
   Declare Sub nag_rand_init_repeatable Lib "CLW3226DE_nag.dll" Alias "g05kfc" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As long, _
    ByRef seed As long, _
    ByVal lseed As long, _
    ByRef state As long, _
    ByRef lstate As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_init_nonrepeatable Lib "CLW3226DE_nag.dll" Alias "g05kgc" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As long, _
    ByRef state As long, _
    ByRef lstate As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_leap_frog Lib "CLW3226DE_nag.dll" Alias "g05khc" ( _
    ByVal n As long, _
    ByVal k As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_skip_ahead Lib "CLW3226DE_nag.dll" Alias "g05kjc" ( _
    ByVal n As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_skip_ahead_power2 Lib "CLW3226DE_nag.dll" Alias "g05kkc" ( _
    ByVal n As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_permute Lib "CLW3226DE_nag.dll" Alias "g05ncc" ( _
    ByRef indx As long, _
    ByVal n As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_sample Lib "CLW3226DE_nag.dll" Alias "g05ndc" ( _
    ByRef ipop As long, _
    ByVal n As long, _
    ByRef isampl As long, _
    ByVal m As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_sample_unequal Lib "CLW3226DE_nag.dll" Alias "g05nec" ( _
    ByVal sortorder As Nag_SortOrder, _
    ByRef wt As double, _
    ByRef ipop As long, _
    ByVal n As long, _
    ByRef isampl As long, _
    ByVal m As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_agarchI Lib "CLW3226DE_nag.dll" Alias "g05pdc" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_agarchII Lib "CLW3226DE_nag.dll" Alias "g05pec" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_garchGJR Lib "CLW3226DE_nag.dll" Alias "g05pfc" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_egarch Lib "CLW3226DE_nag.dll" Alias "g05pgc" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As long, _
    ByVal ip As long, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal df As long, _
    ByRef ht As double, _
    ByRef et As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_arma Lib "CLW3226DE_nag.dll" Alias "g05phc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal xmean As double, _
    ByVal ip As long, _
    ByRef phi As double, _
    ByVal iq As long, _
    ByRef theta As double, _
    ByVal avar As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef var As double, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_varma Lib "CLW3226DE_nag.dll" Alias "g05pjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal k As long, _
    ByRef xmean As double, _
    ByVal p As long, _
    ByRef phi As double, _
    ByVal q As long, _
    ByRef theta As double, _
    ByRef var As double, _
    ByVal pdv As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_exp_smooth Lib "CLW3226DE_nag.dll" Alias "g05pmc" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal n As long, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As long, _
    ByRef param As double, _
    ByRef init As double, _
    ByVal var As double, _
    ByRef r As double, _
    ByRef state As long, _
    ByRef e As double, _
    ByVal en As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_kfold_xyw Lib "CLW3226DE_nag.dll" Alias "g05pvc" ( _
    ByVal k As long, _
    ByVal fold As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal sordx As Nag_DataByObsOrVar, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef nt As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_subsamp_xyw Lib "CLW3226DE_nag.dll" Alias "g05pwc" ( _
    ByVal nt As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal sordx As Nag_DataByObsOrVar, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_orthog_matrix Lib "CLW3226DE_nag.dll" Alias "g05pxc" ( _
    ByVal side As Nag_SideType, _
    ByVal init As Nag_InitializeA, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef state As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_corr_matrix Lib "CLW3226DE_nag.dll" Alias "g05pyc" ( _
    ByVal n As long, _
    ByRef d As double, _
    ByVal eps As double, _
    ByRef state As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_2_way_table Lib "CLW3226DE_nag.dll" Alias "g05pzc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal nrow As long, _
    ByVal ncol As long, _
    ByRef totr As long, _
    ByRef totc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_copula_students_t Lib "CLW3226DE_nag.dll" Alias "g05rcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal df As long, _
    ByVal m As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_copula_normal Lib "CLW3226DE_nag.dll" Alias "g05rdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bivariate_copula_clayton Lib "CLW3226DE_nag.dll" Alias "g05rec" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bivariate_copula_frank Lib "CLW3226DE_nag.dll" Alias "g05rfc" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bivariate_copula_plackett Lib "CLW3226DE_nag.dll" Alias "g05rgc" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_copula_clayton Lib "CLW3226DE_nag.dll" Alias "g05rhc" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_copula_frank Lib "CLW3226DE_nag.dll" Alias "g05rjc" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_copula_gumbel Lib "CLW3226DE_nag.dll" Alias "g05rkc" ( _
    ByVal order as Nag_OrderType, _
    ByRef state As long, _
    ByVal theta As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal sdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_matrix_multi_students_t Lib "CLW3226DE_nag.dll" Alias "g05ryc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal df As long, _
    ByVal m As long, _
    ByRef xmu As double, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_matrix_multi_normal Lib "CLW3226DE_nag.dll" Alias "g05rzc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef xmu As double, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_basic Lib "CLW3226DE_nag.dll" Alias "g05sac" ( _
    ByVal n As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_beta Lib "CLW3226DE_nag.dll" Alias "g05sbc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_cauchy Lib "CLW3226DE_nag.dll" Alias "g05scc" ( _
    ByVal n As long, _
    ByVal xmed As double, _
    ByVal semiqr As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_chi_sq Lib "CLW3226DE_nag.dll" Alias "g05sdc" ( _
    ByVal n As long, _
    ByVal df As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_dirichlet Lib "CLW3226DE_nag.dll" Alias "g05sec" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef a As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_exp Lib "CLW3226DE_nag.dll" Alias "g05sfc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_exp_mix Lib "CLW3226DE_nag.dll" Alias "g05sgc" ( _
    ByVal n As long, _
    ByVal nmix As long, _
    ByRef a As double, _
    ByRef wgt As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_f Lib "CLW3226DE_nag.dll" Alias "g05shc" ( _
    ByVal n As long, _
    ByVal df1 As long, _
    ByVal df2 As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_gamma Lib "CLW3226DE_nag.dll" Alias "g05sjc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_normal Lib "CLW3226DE_nag.dll" Alias "g05skc" ( _
    ByVal n As long, _
    ByVal xmu As double, _
    ByVal var As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_logistic Lib "CLW3226DE_nag.dll" Alias "g05slc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_lognormal Lib "CLW3226DE_nag.dll" Alias "g05smc" ( _
    ByVal n As long, _
    ByVal xmu As double, _
    ByVal var As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_students_t Lib "CLW3226DE_nag.dll" Alias "g05snc" ( _
    ByVal n As long, _
    ByVal df As long, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_triangular Lib "CLW3226DE_nag.dll" Alias "g05spc" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmed As double, _
    ByVal xmax As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_uniform Lib "CLW3226DE_nag.dll" Alias "g05sqc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_von_mises Lib "CLW3226DE_nag.dll" Alias "g05src" ( _
    ByVal n As long, _
    ByVal vk As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_weibull Lib "CLW3226DE_nag.dll" Alias "g05ssc" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef state As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_binomial Lib "CLW3226DE_nag.dll" Alias "g05tac" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_logical Lib "CLW3226DE_nag.dll" Alias "g05tbc" ( _
    ByVal n As long, _
    ByVal p As double, _
    ByRef state As long, _
    ByRef x As Nag_Boolean, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_geom Lib "CLW3226DE_nag.dll" Alias "g05tcc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_gen_discrete Lib "CLW3226DE_nag.dll" Alias "g05tdc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByRef p As double, _
    ByVal np As long, _
    ByVal ip1 As long, _
    ByVal itype As Nag_DiscreteDistrib, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_hypergeometric Lib "CLW3226DE_nag.dll" Alias "g05tec" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal ns As long, _
    ByVal np As long, _
    ByVal m As long, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_logarithmic Lib "CLW3226DE_nag.dll" Alias "g05tfc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal a As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_gen_multinomial Lib "CLW3226DE_nag.dll" Alias "g05tgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal k As long, _
    ByRef p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByVal pdx As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_neg_bin Lib "CLW3226DE_nag.dll" Alias "g05thc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal m As long, _
    ByVal p As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_poisson Lib "CLW3226DE_nag.dll" Alias "g05tjc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As long, _
    ByVal lambda As double, _
    ByRef r As double, _
    ByVal lr As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_compd_poisson Lib "CLW3226DE_nag.dll" Alias "g05tkc" ( _
    ByVal m As long, _
    ByRef vlamda As double, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_discrete_uniform Lib "CLW3226DE_nag.dll" Alias "g05tlc" ( _
    ByVal n As long, _
    ByVal a As long, _
    ByVal b As long, _
    ByRef state As long, _
    ByRef x As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bb_init Lib "CLW3226DE_nag.dll" Alias "g05xac" ( _
    ByVal t0 As double, _
    ByVal tend As double, _
    ByRef times As double, _
    ByVal ntimes As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bb Lib "CLW3226DE_nag.dll" Alias "g05xbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As long, _
    ByVal d As long, _
    ByRef start As double, _
    ByVal a As long, _
    ByRef term As double, _
    ByRef z As double, _
    ByVal pdz As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bb_inc_init Lib "CLW3226DE_nag.dll" Alias "g05xcc" ( _
    ByVal t0 As double, _
    ByVal tend As double, _
    ByRef times As double, _
    ByVal ntimes As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bb_inc Lib "CLW3226DE_nag.dll" Alias "g05xdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As long, _
    ByVal d As long, _
    ByVal a As long, _
    ByRef diff As double, _
    ByRef z As double, _
    ByVal pdz As long, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef b As double, _
    ByVal pdb As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_bb_make_bridge_order Lib "CLW3226DE_nag.dll" Alias "g05xec" ( _
    ByVal bgord As Nag_BridgeOrder, _
    ByVal t0 As double, _
    ByVal tend As double, _
    ByVal ntimes As long, _
    ByRef intime As double, _
    ByVal nmove As long, _
    ByRef move As long, _
    ByRef times As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quasi_rand_normal Lib "CLW3226DE_nag.dll" Alias "g05yjc" ( _
    ByVal order as Nag_OrderType, _
    ByRef xmean As double, _
    ByRef std As double, _
    ByVal n As long, _
    ByRef quas As double, _
    ByVal pdquas As long, _
    ByRef iref As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quasi_rand_lognormal Lib "CLW3226DE_nag.dll" Alias "g05ykc" ( _
    ByVal order as Nag_OrderType, _
    ByRef xmean As double, _
    ByRef std As double, _
    ByVal n As long, _
    ByRef quas As double, _
    ByVal pdquas As long, _
    ByRef iref As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quasi_init Lib "CLW3226DE_nag.dll" Alias "g05ylc" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal idim As long, _
    ByRef iref As long, _
    ByVal liref As long, _
    ByVal iskip As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quasi_rand_uniform Lib "CLW3226DE_nag.dll" Alias "g05ymc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, _
    ByRef quas As double, _
    ByVal pdquas As long, _
    ByRef iref As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_quasi_init_scrambled Lib "CLW3226DE_nag.dll" Alias "g05ync" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal stype As Nag_QuasiRandom_Scrambling, _
    ByVal idim As long, _
    ByRef iref As long, _
    ByVal liref As long, _
    ByVal iskip As long, _
    ByVal nsdigi As long, _
    ByRef state As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_rand_field_1d_user_setup_cov1( _
'      ByVal x As double, _
'      ByRef gamma As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_rand_field_1d_user_setup Lib "CLW3226DE_nag.dll" Alias "g05zmc" ( _
    ByVal ns As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByVal maxm As long, _
    ByVal var As double, _
    ByVal cov1 As Long, _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    ByRef lam As double, _
    ByRef xx As double, _
    ByRef m As long, _
    ByRef approx As long, _
    ByRef rho As double, _
    ByRef icount As long, _
    ByRef eig As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_field_1d_predef_setup Lib "CLW3226DE_nag.dll" Alias "g05znc" ( _
    ByVal ns As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByVal maxm As long, _
    ByVal var As double, _
    ByVal cov As Nag_Variogram, _
    ByVal np As long, _
    ByRef prams As double, _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    ByRef lam As double, _
    ByRef xx As double, _
    ByRef m As long, _
    ByRef approx As long, _
    ByRef rho As double, _
    ByRef icount As long, _
    ByRef eig As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_field_1d_generate Lib "CLW3226DE_nag.dll" Alias "g05zpc" ( _
    ByVal ns As long, _
    ByVal s As long, _
    ByVal m As long, _
    ByRef lam As double, _
    ByVal rho As double, _
    ByRef state As long, _
    ByRef z As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_rand_field_2d_user_setup_cov2( _
'      ByVal x As double, _
'      ByVal y As double, _
'      ByRef gamma As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_rand_field_2d_user_setup Lib "CLW3226DE_nag.dll" Alias "g05zqc" ( _
    ByRef ns As long, ByVal xmin As double, ByVal xmax As double, _
    ByVal ymin As double, ByVal ymax As double, ByRef maxm As long, _
    ByVal var As double, ByVal cov2 As Long, _
    ByVal parity As Nag_Parity, _
    ByVal pad As Nag_EmbedPad, ByVal corr As Nag_EmbedScale, ByRef lam As double, _
    ByRef xx As double, ByRef yy As double, ByRef m As long, _
    ByRef approx As long, ByRef rho As double, ByRef icount As long, _
    ByRef eig As double, ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_field_2d_predef_setup Lib "CLW3226DE_nag.dll" Alias "g05zrc" ( _
    ByRef ns As long, ByVal xmin As double, ByVal xmax As double, _
    ByVal ymin As double, ByVal ymax As double, ByRef maxm As long, _
    ByVal var As double, ByVal cov As Nag_Variogram, ByVal norm As Nag_NormType, _
    ByVal np As long, ByRef prams As double, ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, ByRef lam As double, ByRef xx As double, _
    ByRef yy As double, ByRef m As long, ByRef approx As long, _
    ByRef rho As double, ByRef icount As long, ByRef eig As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_field_2d_generate Lib "CLW3226DE_nag.dll" Alias "g05zsc" ( _
    ByRef ns As long, _
    ByVal s As long, _
    ByRef m As long, _
    ByRef lam As double, _
    ByVal rho As double, _
    ByRef state As long, _
    ByRef z As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rand_field_fracbm_generate Lib "CLW3226DE_nag.dll" Alias "g05ztc" ( _
    ByVal ns As long, _
    ByVal s As long, _
    ByVal m As long, _
    ByVal xmax As double, _
    ByVal h As double, _
    ByRef lam As double, _
    ByVal rho As double, _
    ByRef state As long, _
    ByRef z As double, _
    ByRef xx As double, _
    ByRef fail As NagError _
   )


' chapter g07
   Declare Sub nag_binomial_ci Lib "CLW3226DE_nag.dll" Alias "g07aac" ( _
    ByVal n As long, _
    ByVal k As long, _
    ByVal clevel As double, _
    ByRef pl As double, _
    ByRef pu As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_poisson_ci Lib "CLW3226DE_nag.dll" Alias "g07abc" ( _
    ByVal n As long, _
    ByVal xmean As double, _
    ByVal clevel As double, _
    ByRef tl As double, _
    ByRef tu As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_censored_normal Lib "CLW3226DE_nag.dll" Alias "g07bbc" ( _
    ByVal method As Nag_CEMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef xc As double, _
    ByRef ic As long, _
    ByRef xmu As double, _
    ByRef xsig As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByRef sexmu As double, _
    ByRef sexsig As double, _
    ByRef corr As double, _
    ByRef dev As double, _
    ByRef nobs As long, _
    ByRef nit As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_estim_weibull Lib "CLW3226DE_nag.dll" Alias "g07bec" ( _
    ByVal cens As Nag_CestMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef ic As long, _
    ByRef beta As double, _
    ByRef gamma As double, _
    ByVal tol As double, _
    ByVal maxit As long, _
    ByRef sebeta As double, _
    ByRef segam As double, _
    ByRef corr As double, _
    ByRef dev As double, _
    ByRef nit As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_estim_gen_pareto Lib "CLW3226DE_nag.dll" Alias "g07bfc" ( _
    ByVal n As long, _
    ByRef y As double, _
    ByVal optopt As Nag_OptimOpt, _
    ByRef xi As double, _
    ByRef beta As double, _
    ByRef asvc As double, _
    ByRef obsvc As double, _
    ByRef ll As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_2_sample_t_test Lib "CLW3226DE_nag.dll" Alias "g07cac" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal equal As Nag_PopVar, _
    ByVal nx As long, _
    ByVal ny As long, _
    ByVal xmean As double, _
    ByVal ymean As double, _
    ByVal xstd As double, _
    ByVal ystd As double, _
    ByVal clevel As double, _
    ByRef t As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef dl As double, _
    ByRef du As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_median_1var Lib "CLW3226DE_nag.dll" Alias "g07dac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef xme As double, _
    ByRef xmd As double, _
    ByRef xsd As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_robust_m_estim_1var Lib "CLW3226DE_nag.dll" Alias "g07dbc" ( _
    ByVal sigma_est As Nag_SigmaSimulEst, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal psifun As Nag_PsiFun, _
    ByVal c As double, _
    ByVal h1 As double, _
    ByVal h2 As double, _
    ByVal h3 As double, _
    ByVal dchi As double, _
    ByRef theta As double, _
    ByRef sigma As double, _
    ByVal maxit As long, _
    ByVal tol As double, _
    ByRef rs As double, _
    ByRef nit As long, _
    ByRef sorted_x As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_robust_m_estim_1var_usr_chi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function nag_robust_m_estim_1var_usr_psi( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Sub nag_robust_m_estim_1var_usr Lib "CLW3226DE_nag.dll" Alias "g07dcc" ( _
    ByVal chi As Long, _
    ByVal psi As Long, _
    ByVal isigma As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal beta As double, _
    ByRef theta As double, _
    ByRef sigma As double, _
    ByVal maxit As long, _
    ByVal tol As double, _
    ByRef rs As double, _
    ByRef nit As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_robust_trimmed_1var Lib "CLW3226DE_nag.dll" Alias "g07ddc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal alpha As double, _
    ByRef tmean As double, _
    ByRef wmean As double, _
    ByRef tvar As double, _
    ByRef wvar As double, _
    ByRef k As long, _
    ByRef sx As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rank_ci_1var Lib "CLW3226DE_nag.dll" Alias "g07eac" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal clevel As double, _
    ByRef theta As double, _
    ByRef thetal As double, _
    ByRef thetau As double, _
    ByRef estcl As double, _
    ByRef wlower As double, _
    ByRef wupper As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rank_ci_2var Lib "CLW3226DE_nag.dll" Alias "g07ebc" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal m As long, _
    ByRef y As double, _
    ByVal clevel As double, _
    ByRef theta As double, _
    ByRef thetal As double, _
    ByRef thetau As double, _
    ByRef estcl As double, _
    ByRef ulower As double, _
    ByRef uupper As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_outlier_peirce Lib "CLW3226DE_nag.dll" Alias "g07gac" ( _
    ByVal n As long, _
    ByVal p As long, _
    ByRef y As double, _
    ByVal mean As double, _
    ByVal var As double, _
    ByRef iout As long, _
    ByRef niout As long, _
    ByVal ldiff As long, _
    ByRef diff As double, _
    ByRef llamb As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_outlier_peirce_two_var Lib "CLW3226DE_nag.dll" Alias "g07gbc" ( _
    ByVal n As long, _
    ByVal e As double, _
    ByVal var1 As double, _
    ByVal var2 As double, _
    ByRef x As double, _
    ByRef lx As double, _
    ByRef ux As double, _
    ByRef fail As NagError _
   ) As long


' chapter g08
   Declare Sub nag_sign_test Lib "CLW3226DE_nag.dll" Alias "g08aac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef s As long, _
    ByRef p As double, _
    ByRef non_tied As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_median_test Lib "CLW3226DE_nag.dll" Alias "g08acc" ( _
    ByVal n1 As long, _
    ByRef x As double, _
    ByVal n2 As long, _
    ByRef y As double, _
    ByRef below As long, _
    ByRef above As long, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_friedman_test Lib "CLW3226DE_nag.dll" Alias "g08aec" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal tdx As long, _
    ByRef fr As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_kruskal_wallis_test Lib "CLW3226DE_nag.dll" Alias "g08afc" ( _
    ByVal k As long, _
    ByRef l As long, _
    ByRef x As double, _
    ByVal lx As long, _
    ByRef h As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_wilcoxon_test Lib "CLW3226DE_nag.dll" Alias "g08agc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal median As double, _
    ByVal tail As Nag_TailProbability, _
    ByVal zeros As Nag_IncSignZeros, _
    ByRef w As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef non_zero As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_mann_whitney Lib "CLW3226DE_nag.dll" Alias "g08amc" ( _
    ByVal n1 As long, _
    ByRef x As double, _
    ByVal n2 As long, _
    ByRef y As double, _
    ByVal tail As Nag_TailProbability, _
    ByVal exact As Nag_CompProb, _
    ByRef u As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_1_sample_ks_test Lib "CLW3226DE_nag.dll" Alias "g08cbc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal dist As Nag_Distributions, _
    ByRef par As double, _
    ByVal estima As Nag_ParaEstimates, _
    ByVal ntype As Nag_TestStatistics, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_2_sample_ks_test Lib "CLW3226DE_nag.dll" Alias "g08cdc" ( _
    ByVal n1 As long, _
    ByRef x As double, _
    ByVal n2 As long, _
    ByRef y As double, _
    ByVal dtype As Nag_TestStatistics, _
    ByRef d As double, _
    ByRef z As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_chi_sq_goodness_of_fit_test Lib "CLW3226DE_nag.dll" Alias "g08cgc" ( _
    ByVal nclass As long, _
    ByRef ifreq As long, _
    ByRef ci As double, _
    ByVal dist As Nag_Distributions, _
    ByRef par As double, _
    ByVal npest As long, _
    ByRef prob As double, _
    ByRef chisq As double, _
    ByRef p As double, _
    ByRef ndf As long, _
    ByRef eval As double, _
    ByRef chisqi As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_anderson_darling_stat Lib "CLW3226DE_nag.dll" Alias "g08chc" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_anderson_darling_uniform_prob Lib "CLW3226DE_nag.dll" Alias "g08cjc" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef a2 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_anderson_darling_normal_prob Lib "CLW3226DE_nag.dll" Alias "g08ckc" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef ybar As double, _
    ByRef yvar As double, _
    ByRef a2 As double, _
    ByRef aa2 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_anderson_darling_exp_prob Lib "CLW3226DE_nag.dll" Alias "g08clc" ( _
    ByVal n As long, _
    ByVal issort As Nag_Boolean, _
    ByRef y As double, _
    ByRef ybar As double, _
    ByRef a2 As double, _
    ByRef aa2 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_runs_test Lib "CLW3226DE_nag.dll" Alias "g08eac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal max_run As long, _
    ByRef nruns As long, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_pairs_test Lib "CLW3226DE_nag.dll" Alias "g08ebc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal max_count As long, _
    ByVal lag As long, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_triplets_test Lib "CLW3226DE_nag.dll" Alias "g08ecc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal max_count As long, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_gaps_test Lib "CLW3226DE_nag.dll" Alias "g08edc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal num_gaps As long, _
    ByVal max_gap As long, _
    ByVal lower As double, _
    ByVal upper As double, _
    ByVal length As double, _
    ByRef chi As double, _
    ByRef df As double, _
    ByRef prob As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rank_regsn Lib "CLW3226DE_nag.dll" Alias "g08rac" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As long, _
    ByRef nv As long, _
    ByRef y As double, _
    ByVal p As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByVal idist As long, _
    ByVal nmax As long, _
    ByVal tol As double, _
    ByRef prvr As double, _
    ByVal pdparvar As long, _
    ByRef irank As long, _
    ByRef zin As double, _
    ByRef eta As double, _
    ByRef vapvec As double, _
    ByRef parest As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_rank_regsn_censored Lib "CLW3226DE_nag.dll" Alias "g08rbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As long, _
    ByRef nv As long, _
    ByRef y As double, _
    ByVal p As long, _
    ByRef x As double, _
    ByVal pdx As long, _
    ByRef icen As long, _
    ByVal gamma As double, _
    ByVal nmax As long, _
    ByVal tol As double, _
    ByRef prvr As double, _
    ByVal pdprvr As long, _
    ByRef irank As long, _
    ByRef zin As double, _
    ByRef eta As double, _
    ByRef vapvec As double, _
    ByRef parest As double, _
    ByRef fail As NagError _
   )


' chapter g10
   Declare Sub nag_smooth_spline_fit Lib "CLW3226DE_nag.dll" Alias "g10abc" ( _
    ByVal mode As Nag_SmoothFitType, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByVal rho As double, _
    ByRef yhat As double, _
    ByRef c As double, _
    ByVal pdc As long, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef res As double, _
    ByRef h As double, _
    ByRef comm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_smooth_spline_estim Lib "CLW3226DE_nag.dll" Alias "g10acc" ( _
    ByVal method As Nag_SmoothParamMethods, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByRef yhat As double, _
    ByRef coeff As double, _
    ByRef rss As double, _
    ByRef df As double, _
    ByRef res As double, _
    ByRef h As double, _
    ByRef crit As double, _
    ByRef rho As double, _
    ByVal u As double, _
    ByVal tol As double, _
    ByVal maxcal As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_kernel_density_gauss Lib "CLW3226DE_nag.dll" Alias "g10bbc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal wtype As Nag_WindowType, _
    ByRef window As double, _
    ByRef slo As double, _
    ByRef shi As double, _
    ByVal ns As long, _
    ByRef smooth As double, _
    ByRef t As double, _
    ByVal fcall As Nag_Boolean, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_running_median_smoother Lib "CLW3226DE_nag.dll" Alias "g10cac" ( _
    ByVal smoother As Nag_Smooth_Type, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef smooth As double, _
    ByRef rough As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_order_data Lib "CLW3226DE_nag.dll" Alias "g10zac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByRef nord As long, _
    ByRef xord As double, _
    ByRef yord As double, _
    ByRef wwt As double, _
    ByRef rss As double, _
    ByRef fail As NagError _
   )


' chapter g11
   Declare Sub nag_chi_sq_2_way_table Lib "CLW3226DE_nag.dll" Alias "g11aac" ( _
    ByVal nrow As long, _
    ByVal ncol As long, _
    ByRef nobst As long, _
    ByVal tdt As long, _
    ByRef expt As double, _
    ByRef chist As double, _
    ByRef prob As double, _
    ByRef chi As double, _
    ByRef g As double, _
    ByRef df As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tabulate_stats Lib "CLW3226DE_nag.dll" Alias "g11bac" ( _
    ByVal stat As Nag_TableStats, _
    ByVal update As Nag_TableUpdate, _
    ByVal weight As Nag_Weightstype, _
    ByVal n As long, _
    ByVal nfac As long, _
    ByRef sf As long, _
    ByRef lfac As long, _
    ByRef factor As long, _
    ByVal tdf As long, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef table As double, _
    ByVal maxt As long, _
    ByRef ncells As long, _
    ByRef ndim As long, _
    ByRef idim As long, _
    ByRef count As long, _
    ByRef comm_ar As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tabulate_percentile Lib "CLW3226DE_nag.dll" Alias "g11bbc" ( _
    ByVal typ As Nag_TabulateVar, _
    ByVal n As long, _
    ByVal nfac As long, _
    ByRef sf As long, _
    ByRef lfac As long, _
    ByRef factor As long, _
    ByVal tdf As long, _
    ByVal percnt As double, _
    ByRef y As double, _
    ByRef wt As double, _
    ByRef table As double, _
    ByVal maxt As long, _
    ByRef ncells As long, _
    ByRef ndim As long, _
    ByRef idim As long, _
    ByRef count As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tabulate_margin Lib "CLW3226DE_nag.dll" Alias "g11bcc" ( _
    ByVal stat As Nag_TableStats, _
    ByRef table As double, _
    ByVal ncells As long, _
    ByVal ndim As long, _
    ByRef idim As long, _
    ByRef isdim As long, _
    ByRef sub_table As double, _
    ByVal maxst As long, _
    ByRef mcells As long, _
    ByRef mdim As long, _
    ByRef mlevel As long, _
    ByRef comm_ar As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_condl_logistic Lib "CLW3226DE_nag.dll" Alias "g11cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByVal ns As long, _
    ByRef z As double, ByVal pdz As long, ByRef isz As long, _
    ByVal p As long, ByRef ic As long, ByRef isi As long, _
    ByRef dev As double, ByRef b As double, ByRef se As double, _
    ByRef sc As double, ByRef cov As double, ByRef nca As long, _
    ByRef nct As long, ByVal tol As double, ByVal maxit As long, _
    ByVal iprint As long, ByVal outfile As String, ByRef fail As NagError _
   )

   Declare Sub nag_binary_factor Lib "CLW3226DE_nag.dll" Alias "g11sac" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As long, ByVal n As long, ByVal gprob As Nag_Boolean, _
    ByVal ns As long, ByRef x As Nag_Boolean, ByVal pdx As long, _
    ByRef irl As long, ByRef a As double, ByRef c As double, _
    ByVal iprint As long, ByVal outfile As String, ByVal cgetol As double, _
    ByVal maxit As long, ByVal chisqr As Nag_Boolean, ByRef niter As long, _
    ByRef alpha As double, ByRef pigam As double, ByRef cm As double, _
    ByVal pdcm As long, ByRef g As double, ByRef expp As double, _
    ByVal pde As long, ByRef obs As double, ByRef exf As double, _
    ByRef y As double, ByRef iob As long, ByRef rlogl As double, _
    ByRef chi As double, ByRef idf As long, ByRef siglev As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_binary_factor_service Lib "CLW3226DE_nag.dll" Alias "g11sbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As long, _
    ByVal n As long, _
    ByRef ns As long, _
    ByRef x As Nag_Boolean, _
    ByVal pdx As long, _
    ByRef irl As long, _
    ByRef fail As NagError _
   )


' chapter g12
   Declare Sub nag_prod_limit_surviv_fn Lib "CLW3226DE_nag.dll" Alias "g12aac" ( _
    ByVal n As long, _
    ByRef t As double, _
    ByRef ic As long, _
    ByRef freq As long, _
    ByRef nd As long, _
    ByRef tp As double, _
    ByRef p As double, _
    ByRef psig As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_surviv_logrank Lib "CLW3226DE_nag.dll" Alias "g12abc" ( _
    ByVal n As long, _
    ByRef t As double, _
    ByRef ic As long, _
    ByRef grp As long, _
    ByVal ngrp As long, _
    ByRef ifreq As long, _
    ByRef wt As double, _
    ByRef ts As double, _
    ByRef df As long, _
    ByRef p As double, _
    ByRef obsd As double, _
    ByRef expt As double, _
    ByRef nd As long, _
    ByRef di As long, _
    ByRef ni As long, _
    ByVal ldn As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_surviv_cox_model Lib "CLW3226DE_nag.dll" Alias "g12bac" ( _
    ByVal n As long, ByVal m As long, ByVal ns As long, _
    ByRef z As double, ByVal tdz As long, ByRef sz As long, _
    ByVal ip As long, ByRef t As double, ByRef ic As long, _
    ByRef omega As double, ByRef isi As long, ByRef dev As double, _
    ByRef b As double, ByRef se As double, ByRef sc As double, _
    ByRef cov As double, ByRef res As double, ByRef nd As long, _
    ByRef tp As double, ByRef sur As double, ByVal tdsur As long, _
    ByVal ndmax As long, ByVal tol As double, ByVal max_iter As long, _
    ByVal iprint As long, ByVal outfile As String, ByRef fail As NagError _
   )

   Declare Sub nag_surviv_risk_sets Lib "CLW3226DE_nag.dll" Alias "g12zac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As long, ByVal m As long, ByVal ns As long, _
    ByRef z As double, ByVal pdz As long, ByRef isz As long, _
    ByVal ip As long, ByRef t As double, ByRef ic As long, _
    ByRef isi As long, ByRef num As long, ByRef ixs As long, _
    ByRef nxs As long, ByRef x As double, ByVal mxn As long, _
    ByRef id As long, ByRef nd As long, ByRef tp As double, _
    ByRef irs As long, ByRef fail As NagError _
   )


' chapter g13
   Declare Sub nag_tsa_diff Lib "CLW3226DE_nag.dll" Alias "g13aac" ( _
    ByRef x As double, _
    ByVal nx As long, _
    ByVal d As long, _
    ByVal ds As long, _
    ByVal s As long, _
    ByRef xd As double, _
    ByRef nxd As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_auto_corr Lib "CLW3226DE_nag.dll" Alias "g13abc" ( _
    ByRef x As double, _
    ByVal nx As long, _
    ByVal nk As long, _
    ByRef mean As double, _
    ByRef var As double, _
    ByRef r As double, _
    ByRef stat As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_auto_corr_part Lib "CLW3226DE_nag.dll" Alias "g13acc" ( _
    ByRef r As double, _
    ByVal nk As long, _
    ByVal nl As long, _
    ByRef p As double, _
    ByRef v As double, _
    ByRef ar As double, _
    ByRef nvl As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_exp_smooth Lib "CLW3226DE_nag.dll" Alias "g13amc" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As long, _
    ByRef param As double, _
    ByVal n As long, _
    ByRef y As double, _
    ByVal k As long, _
    ByRef init As double, _
    ByVal nf As long, _
    ByRef fv As double, _
    ByRef fse As double, _
    ByRef yhat As double, _
    ByRef res As double, _
    ByRef dv As double, _
    ByRef ad As double, _
    ByRef r As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_resid_corr Lib "CLW3226DE_nag.dll" Alias "g13asc" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal n As long, _
    ByRef v As double, _
    ByVal m As long, _
    ByRef par As double, _
    ByVal narma As long, _
    ByRef r As double, _
    ByRef rc As double, _
    ByVal tdrc As long, _
    ByRef chi As double, _
    ByRef df As long, _
    ByRef siglev As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_mean_range Lib "CLW3226DE_nag.dll" Alias "g13auc" ( _
    ByVal n As long, _
    ByRef z As double, _
    ByVal m As long, _
    ByVal rs As Nag_RangeStat, _
    ByRef y As double, _
    ByRef mean As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_tsa_dickey_fuller_unit Lib "CLW3226DE_nag.dll" Alias "g13awc" ( _
    ByVal typ As Nag_TS_URTestType, _
    ByVal p As long, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_tsa_arma_filter Lib "CLW3226DE_nag.dll" Alias "g13bac" ( _
    ByRef y As double, _
    ByVal ny As long, _
    ByRef arimaf As Nag_ArimaOrder, _
    ByRef arimav As Nag_ArimaOrder, _
    ByRef par As double, _
    ByVal npar As long, _
    ByVal cy As double, _
    ByRef b As double, _
    ByVal nb As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_transf_filter Lib "CLW3226DE_nag.dll" Alias "g13bbc" ( _
    ByRef y As double, _
    ByVal ny As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef arimas As Nag_ArimaOrder, _
    ByRef par As double, _
    ByVal npar As long, _
    ByVal cy As double, _
    ByRef b As double, _
    ByVal nb As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_cross_corr Lib "CLW3226DE_nag.dll" Alias "g13bcc" ( _
    ByRef x As double, _
    ByRef y As double, _
    ByVal nxy As long, _
    ByVal nl As long, _
    ByRef s As double, _
    ByRef r0 As double, _
    ByRef r As double, _
    ByRef stat As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_transf_prelim_fit Lib "CLW3226DE_nag.dll" Alias "g13bdc" ( _
    ByVal r0 As double, _
    ByRef r As double, _
    ByVal nl As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByVal s As double, _
    ByRef wds As double, _
    ByRef isf As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_inp_model_estim Lib "CLW3226DE_nag.dll" Alias "g13bec" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef para As double, _
    ByVal npara As long, _
    ByVal nxxy As long, _
    ByRef xxy As double, _
    ByVal tdxxy As long, _
    ByRef sd As double, _
    ByRef rss As double, _
    ByRef objf As double, _
    ByRef df As double, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_inp_update Lib "CLW3226DE_nag.dll" Alias "g13bgc" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nser As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef para As double, _
    ByVal npara As long, _
    ByVal nnv As long, _
    ByRef xxyn As double, _
    ByVal tdxxyn As long, _
    ByVal kzef As long, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_inp_model_forecast Lib "CLW3226DE_nag.dll" Alias "g13bjc" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef para As double, _
    ByVal npara As long, _
    ByVal nev As long, _
    ByVal nfv As long, _
    ByRef xxy As double, _
    ByVal tdxxy As long, _
    ByRef rmsxy As double, _
    ByRef mrx As long, _
    ByVal tdmrx As long, _
    ByRef parx As double, _
    ByVal ldparx As long, _
    ByVal tdparx As long, _
    ByRef fva As double, _
    ByRef fsd As double, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_options_init Lib "CLW3226DE_nag.dll" Alias "g13bxc" ( _
    ByRef ops As Nag_G13_Opt _
   )

   Declare Sub nag_tsa_transf_orders Lib "CLW3226DE_nag.dll" Alias "g13byc" ( _
    ByVal nseries As long, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_trans_free Lib "CLW3226DE_nag.dll" Alias "g13bzc" ( _
    ByRef transfv As Nag_TransfOrder _
   )

   Declare Sub nag_tsa_spectrum_univar_cov Lib "CLW3226DE_nag.dll" Alias "g13cac" ( _
    ByVal nx As long, _
    ByVal mtx As long, _
    ByVal px As double, _
    ByVal iw As long, _
    ByVal mw As long, _
    ByVal ic As long, _
    ByVal nc As long, _
    ByRef c As double, _
    ByVal kc As long, _
    ByVal l As long, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    ByVal nxg As long, _
    ByRef xg As double, _
    ByRef ng As long, _
    ByRef stats As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_spectrum_univar Lib "CLW3226DE_nag.dll" Alias "g13cbc" ( _
    ByVal nx As long, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal px As double, _
    ByVal mw As long, _
    ByVal pw As double, _
    ByVal l As long, _
    ByVal kc As long, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    ByRef x As double, _
    ByRef gptr As Long, _
    ByRef ng As long, _
    ByRef stats As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_spectrum_bivar_cov Lib "CLW3226DE_nag.dll" Alias "g13ccc" ( _
    ByVal nxy As long, _
    ByVal mtxy_correction As NagMeanOrTrend, _
    ByVal pxy As double, _
    ByVal iw As long, _
    ByVal mw As long, _
    ByVal ish As long, _
    ByVal ic As long, _
    ByVal nc As long, _
    ByRef cxy As double, _
    ByRef cyx As double, _
    ByVal kc As long, _
    ByVal l As long, _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef g As Complex, _
    ByRef ng As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_spectrum_bivar Lib "CLW3226DE_nag.dll" Alias "g13cdc" ( _
    ByVal nxy As long, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal pxy As double, _
    ByVal mw As long, _
    ByVal s As long, _
    ByVal pw As double, _
    ByVal l As long, _
    ByVal kc As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef g As Complex, _
    ByRef ng As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_cross_spectrum_bivar Lib "CLW3226DE_nag.dll" Alias "g13cec" ( _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef xyg As Complex, _
    ByVal ng As long, _
    ByRef stats As double, _
    ByRef ca As double, _
    ByRef calw As double, _
    ByRef caup As double, _
    ByRef t As double, _
    ByRef sc As double, _
    ByRef sclw As double, _
    ByRef scup As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_gain_phase_bivar Lib "CLW3226DE_nag.dll" Alias "g13cfc" ( _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef xyg As Complex, _
    ByVal ng As long, _
    ByRef stats As double, _
    ByRef gn As double, _
    ByRef gnlw As double, _
    ByRef gnup As double, _
    ByRef ph As double, _
    ByRef phlw As double, _
    ByRef phup As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_noise_spectrum_bivar Lib "CLW3226DE_nag.dll" Alias "g13cgc" ( _
    ByRef xg As double, _
    ByRef yg As double, _
    ByRef xyg As Complex, _
    ByVal ng As long, _
    ByRef stats As double, _
    ByVal l As long, _
    ByVal n As long, _
    ByRef er As double, _
    ByRef erlw As double, _
    ByRef erup As double, _
    ByRef rf As double, _
    ByRef rfse As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_auto_corr_part Lib "CLW3226DE_nag.dll" Alias "g13dbc" ( _
    ByRef c0 As double, _
    ByRef c As double, _
    ByVal ns As long, _
    ByVal nl As long, _
    ByVal nk As long, _
    ByRef p As double, _
    ByRef v0 As double, _
    ByRef v As double, _
    ByRef d As double, _
    ByRef db As double, _
    ByRef w As double, _
    ByRef wb As double, _
    ByRef nvp As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_varma_estimate Lib "CLW3226DE_nag.dll" Alias "g13ddc" ( _
    ByVal k As long, ByVal n As long, ByVal ip As long, _
    ByVal iq As long, ByVal mean As Nag_IncludeMean, ByRef par As double, _
    ByVal npar As long, ByRef qq As double, ByVal kmax As long, _
    ByRef w As double, ByRef parhld As Nag_Boolean, ByVal exact As Nag_Boolean, _
    ByVal iprint As long, ByVal cgetol As double, ByVal maxcal As long, _
    ByVal ishow As long, ByVal outfile As String, ByRef niter As long, _
    ByRef rlogl As double, ByRef v As double, ByRef g As double, _
    ByRef cm As double, ByVal pdcm As long, ByRef fail As NagError _
   )

   Declare Sub nag_tsa_varma_forecast Lib "CLW3226DE_nag.dll" Alias "g13djc" ( _
    ByVal k As long, ByVal n As long, ByRef z As double, _
    ByVal kmax As long, ByRef tr As long, ByRef id As long, _
    ByRef delta As double, ByVal ip As long, ByVal iq As long, _
    ByVal mean As Nag_IncludeMean, ByRef par As double, ByVal lpar As long, _
    ByRef qq As double, ByRef v As double, ByVal lmax As long, _
    ByRef predz As double, ByRef sefz As double, ByRef dnref As double, _
    ByVal lref As long, ByRef fail As NagError _
   )

   Declare Sub nag_tsa_varma_update Lib "CLW3226DE_nag.dll" Alias "g13dkc" ( _
    ByVal k As long, _
    ByVal lmax As long, _
    ByVal m As long, _
    ByRef mlastptr As Long, _
    ByRef z As double, _
    ByVal kmax As long, _
    ByRef dnref As double, _
    ByVal lref As long, _
    ByRef v As double, _
    ByRef predz As double, _
    ByRef sefz As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_diff Lib "CLW3226DE_nag.dll" Alias "g13dlc" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByRef z As double, _
    ByRef tr As long, _
    ByRef id As long, _
    ByRef delta As double, _
    ByRef w As double, _
    ByRef nd As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_cross_corr Lib "CLW3226DE_nag.dll" Alias "g13dmc" ( _
    ByVal matrix As Nag_CovOrCorr, _
    ByVal k As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef w As double, _
    ByRef wmean As double, _
    ByRef r0 As double, _
    ByRef r As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_part_lag_corr Lib "CLW3226DE_nag.dll" Alias "g13dnc" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef r0 As double, _
    ByRef r As double, _
    ByRef maxlag As long, _
    ByRef parlag As double, _
    ByRef x As double, _
    ByRef pvalue As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_multi_part_regsn Lib "CLW3226DE_nag.dll" Alias "g13dpc" ( _
    ByVal k As long, _
    ByVal n As long, _
    ByRef z As double, _
    ByVal m As long, _
    ByRef maxlag As long, _
    ByRef parlag As double, _
    ByRef se As double, _
    ByRef qq As double, _
    ByRef x As double, _
    ByRef pvalue As double, _
    ByRef loglhd As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_varma_diagnostic Lib "CLW3226DE_nag.dll" Alias "g13dsc" ( _
    ByVal k As long, ByVal n As long, ByRef v As double, _
    ByVal kmax As long, ByVal ip As long, ByVal iq As long, _
    ByVal m As long, ByRef par As double, ByRef parhld As Nag_Boolean, _
    ByRef qq As double, ByVal ishow As long, ByVal outfile As String, _
    ByRef r0 As double, ByRef r As double, ByRef rcm As double, _
    ByVal pdrcm As long, ByRef chi As double, ByRef idf As long, _
    ByRef siglev As double, ByRef fail As NagError _
   )

   Declare Sub nag_tsa_arma_roots Lib "CLW3226DE_nag.dll" Alias "g13dxc" ( _
    ByVal k As long, _
    ByVal ip As long, _
    ByRef par As double, _
    ByRef rr As double, _
    ByRef ri As double, _
    ByRef rmod As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_kalman_sqrt_filt_cov_var Lib "CLW3226DE_nag.dll" Alias "g13eac" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByRef s As double, ByVal tds As long, ByRef a As double, _
    ByVal tda As long, ByRef b As double, ByVal tdb As long, _
    ByRef q As double, ByVal tdq As long, ByRef c As double, _
    ByVal tdc As long, ByRef r As double, ByVal tdr As long, _
    ByRef k As double, ByVal tdk As long, ByRef h As double, _
    ByVal tdh As long, ByVal tol As double, ByRef fail As NagError _
   )

   Declare Sub nag_kalman_sqrt_filt_cov_invar Lib "CLW3226DE_nag.dll" Alias "g13ebc" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByRef s As double, ByVal tds As long, ByRef a As double, _
    ByVal tda As long, ByRef b As double, ByVal tdb As long, _
    ByRef q As double, ByVal tdq As long, ByRef c As double, _
    ByVal tdc As long, ByRef r As double, ByVal tdr As long, _
    ByRef k As double, ByVal tdk As long, ByRef h As double, _
    ByVal tdh As long, ByVal tol As double, ByRef fail As NagError _
   )

   Declare Sub nag_kalman_sqrt_filt_info_var Lib "CLW3226DE_nag.dll" Alias "g13ecc" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByVal inp_ab As Nag_ab_input, ByRef t As double, ByVal tdt As long, _
    ByRef ainv As double, ByVal tda As long, ByRef b As double, _
    ByVal tdb As long, ByRef rinv As double, ByVal tdr As long, _
    ByRef c As double, ByVal tdc As long, ByRef qinv As double, _
    ByVal tdq As long, ByRef x As double, ByRef rinvy As double, _
    ByRef z As double, ByVal tol As double, ByRef fail As NagError _
   )

   Declare Sub nag_kalman_sqrt_filt_info_invar Lib "CLW3226DE_nag.dll" Alias "g13edc" ( _
    ByVal n As long, ByVal m As long, ByVal p As long, _
    ByRef t As double, ByVal tdt As long, ByRef ainv As double, _
    ByVal tda As long, ByRef ainvb As double, ByVal tdai As long, _
    ByRef rinv As double, ByVal tdr As long, ByRef c As double, _
    ByVal tdc As long, ByRef qinv As double, ByVal tdq As long, _
    ByRef x As double, ByRef rinvy As double, ByRef z As double, _
    ByVal tol As double, ByRef fail As NagError _
   )

   Declare Sub nag_kalman_unscented_state_revcom Lib "CLW3226DE_nag.dll" Alias "g13ejc" ( _
    ByRef irevcm As long, ByVal mx As long, ByVal my As long, _
    ByRef y As double, ByRef lx As double, ByVal pdlx As long, _
    ByRef ly As double, ByVal pdly As long, ByRef x As double, _
    ByRef st As double, ByVal pdst As long, ByRef n As long, _
    ByRef xt As double, ByVal pdxt As long, ByRef fxt As double, _
    ByVal pdfxt As long, ByRef ropt As double, ByVal lropt As long, _
    ByRef icomm As long, ByVal licomm As long, ByRef rcomm As double, _
    ByVal lrcomm As long, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_kalman_unscented_state_f( _
'      ByVal mx As long, _
'      ByVal n As long, _
'      ByVal xt_rptr As Long, _
'      ByVal fxt_rptr As Long, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_kalman_unscented_state_h( _
'      ByVal mx As long, _
'      ByVal my As long, _
'      ByVal n As long, _
'      ByVal yt_rptr As Long, _
'      ByVal hyt_rptr As Long, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_kalman_unscented_state Lib "CLW3226DE_nag.dll" Alias "g13ekc" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef y As double, _
    ByRef lx As double, _
    ByRef ly As double, _
    ByVal f As Long, _
    ByVal h As Long, _
    ByRef x As double, _
    ByRef st As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_trans_hessenberg_observer Lib "CLW3226DE_nag.dll" Alias "g13ewc" ( _
    ByVal n As long, _
    ByVal p As long, _
    ByVal reduceto As Nag_ObserverForm, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef c As double, _
    ByVal tdc As long, _
    ByRef u As double, _
    ByVal tdu As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_trans_hessenberg_controller Lib "CLW3226DE_nag.dll" Alias "g13exc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByVal reduceto As Nag_ControllerForm, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef b As double, _
    ByVal tdb As long, _
    ByRef u As double, _
    ByVal tdu As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_estimate_agarchI Lib "CLW3226DE_nag.dll" Alias "g13fac" ( _
    ByRef yt As double, ByRef x As double, ByVal tdx As long, _
    ByVal num As long, ByVal p As long, ByVal q As long, _
    ByVal nreg As long, ByVal mn As long, ByVal isym As long, _
    ByRef theta As double, ByRef se As double, ByRef sc As double, _
    ByRef covar As double, ByVal tdc As long, ByRef hp As double, _
    ByRef et As double, ByRef ht As double, ByRef lgf As double, _
    ByVal stat_opt As Nag_Garch_Stationary_Type, ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As long, _
    ByVal tol As double, ByRef fail As NagError _
   )

   Declare Sub nag_forecast_agarchI Lib "CLW3226DE_nag.dll" Alias "g13fbc" ( _
    ByVal num As long, _
    ByVal nt As long, _
    ByVal p As long, _
    ByVal q As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByRef fht As double, _
    ByRef ht As double, _
    ByRef et As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_estimate_agarchII Lib "CLW3226DE_nag.dll" Alias "g13fcc" ( _
    ByRef yt As double, ByRef x As double, ByVal tdx As long, _
    ByVal num As long, ByVal p As long, ByVal q As long, _
    ByVal nreg As long, ByVal mn As long, ByRef theta As double, _
    ByRef se As double, ByRef sc As double, ByRef covar As double, _
    ByVal tdc As long, ByRef hp As double, ByRef et As double, _
    ByRef ht As double, ByRef lgf As double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As long, ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_forecast_agarchII Lib "CLW3226DE_nag.dll" Alias "g13fdc" ( _
    ByVal num As long, _
    ByVal nt As long, _
    ByVal p As long, _
    ByVal q As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByRef fht As double, _
    ByRef ht As double, _
    ByRef et As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_estimate_garchGJR Lib "CLW3226DE_nag.dll" Alias "g13fec" ( _
    ByRef yt As double, ByRef x As double, ByVal tdx As long, _
    ByVal num As long, ByVal p As long, ByVal q As long, _
    ByVal nreg As long, ByVal mn As long, ByRef theta As double, _
    ByRef se As double, ByRef sc As double, ByRef covar As double, _
    ByVal tdc As long, ByRef hp As double, ByRef et As double, _
    ByRef ht As double, ByRef lgf As double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As long, ByVal tol As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_forecast_garchGJR Lib "CLW3226DE_nag.dll" Alias "g13ffc" ( _
    ByVal num As long, _
    ByVal nt As long, _
    ByVal p As long, _
    ByVal q As long, _
    ByRef theta As double, _
    ByVal gamma As double, _
    ByRef fht As double, _
    ByRef ht As double, _
    ByRef et As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_inhom_iema Lib "CLW3226DE_nag.dll" Alias "g13mec" ( _
    ByVal nb As long, _
    ByRef iema As double, _
    ByRef t As double, _
    ByVal tau As double, _
    ByVal m As long, _
    ByRef sinit As double, _
    ByRef inter As Nag_TS_Interpolation, _
    ByRef pn As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_inhom_iema_all Lib "CLW3226DE_nag.dll" Alias "g13mfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal nb As long, _
    ByRef z As double, _
    ByRef iema As double, _
    ByVal pdiema As long, _
    ByRef t As double, _
    ByVal tau As double, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByRef sinit As double, _
    ByRef inter As Nag_TS_Interpolation, _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As double, _
    ByRef x As double, _
    ByRef pn As long, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_inhom_ma Lib "CLW3226DE_nag.dll" Alias "g13mgc" ( _
    ByVal nb As long, _
    ByRef ma As double, _
    ByRef t As double, _
    ByVal tau As double, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByRef sinit As double, _
    ByRef inter As Nag_TS_Interpolation, _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As double, _
    ByRef pn As long, _
    ByRef wma As double, _
    ByRef rcomm As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_cp_pelt Lib "CLW3226DE_nag.dll" Alias "g13nac" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As long, _
    ByRef y As double, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByRef param As double, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef sparam As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_tsa_cp_pelt_user_costfn( _
'      ByVal ts As long, _
'      ByVal nr As long, _
'      ByVal r_iptr As Long, _
'      ByVal c_rptr As Long, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_tsa_cp_pelt_user Lib "CLW3226DE_nag.dll" Alias "g13nbc" ( _
    ByVal n As long, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByVal k As double, _
    ByVal costfn As Long, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_cp_binary Lib "CLW3226DE_nag.dll" Alias "g13ndc" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As long, _
    ByRef y As double, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByRef param As double, _
    ByVal mdepth As long, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef sparam As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_tsa_cp_binary_user_chgpfn( _
'      ByVal side As Nag_TS_SegSide, _
'      ByVal u As long, _
'      ByVal w As long, _
'      ByVal minss As long, _
'      ByRef v As long, _
'      ByVal cost_rptr As Long, _
'      ByRef comm As Nag_Comm, _
'      ByRef info As long _
'    )
'      ' your code here
'  End Sub

   Declare Sub nag_tsa_cp_binary_user Lib "CLW3226DE_nag.dll" Alias "g13nec" ( _
    ByVal n As long, _
    ByVal beta As double, _
    ByVal minss As long, _
    ByVal mdepth As long, _
    ByVal chgpfn As Long, _
    ByRef ntau As long, _
    ByRef tau As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub nag_tsa_free Lib "CLW3226DE_nag.dll" Alias "g13xzc" ( _
    ByRef ops As Nag_G13_Opt _
   )

