

' VB6/VBA declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.




Public Const NAG_FILE_LEN As long = 512
Public Const NAG_ERROR_BUF_LEN As long = 512
Public Const MPS_NAME_LEN As long = 8


    

' type declarations




Type Complex
    re As double
    im As double
End Type



Type Nag_Sparse_Comm
    idatax (1 to 20) As long
    rdatax (1 to 20) As double
    idata (1 to 20) As long
    rdata (1 to 20) As double
    work As Long ' pointer to double
    iwork As Long ' pointer to long
    lwork As long
    liwork As long
    f11gac_lwreq As long
    f11bby_iter As long
    f11bby_jump As long
    f11bby_j As long
    f11bby_kase As long
    f11gbz_ib As long
    f11gbz_id As long
    f11gbz_ie2 As long
    f11gbz_infoch As long
    f11gbz_ip As long
    f11gbz_ir As long
    f11gbz_iterm As long
    f11gbz_itn As long
    f11gbz_its As long
    f11gbz_iw As long
    f11gbz_iwgt As long
    f11gbz_ix As long
    f11gbz_maxitn As long
    f11gbz_maxits As long
    f11gbz_monit As long
    f11gbz_n As long
    f11gbz_norm As long
    f11gbz_sigcmp As long
    f11gbz_sigcmx As long
    f11gbz_stage As long
    pad33 As long ' Pad to double-word boundary
    f11gbz_anorm As double
    f11gbz_bnorm As double
    f11gbz_sigerr As double
    f11gbz_sigerc As double
    f11gbz_sigmax As double
    f11gbz_sigmac As double
    f11gbz_stplhs As double
    f11gbz_stprhs As double
    f11gbz_talpha As double
    f11gbz_tbeta As double
    f11gbz_tol As double
    f11gbz_xnorm As double
    f11gbz_floop as Nag_Boolean
    f11gbz_next as Nag_Boolean
    f11gbz_precon as Nag_SparseSym_PrecType
    pad48 As long ' Pad to double-word boundary
    f11gby_alpha As double
    f11gby_anorm As double
    f11gby_beta1 As double
    f11gby_beta2 As double
    f11gby_betain As double
    f11gby_bnorm As double
    f11gby_bnorm2 As double
    f11gby_gammab As double
    f11gby_pi As double
    f11gby_rho1 As double
    f11gby_rho2 As double
    f11gby_rnorm2 As double
    f11gby_sigerr As double
    f11gby_sigerc As double
    f11gby_sigmax As double
    f11gby_sigmac As double
    f11gby_stplhs As double
    f11gby_stprhs As double
    f11gby_tol As double
    f11gby_xnorm As double
    f11gby_xnorm0 As double
    f11gby_zeta As double
    f11gby_zetab As double
    f11gby_ib As long
    f11gby_id As long
    f11gby_ie2 As long
    f11gby_infoch As long
    f11gby_iterm As long
    f11gby_itn As long
    f11gby_its As long
    f11gby_iv1 As long
    f11gby_iv2 As long
    f11gby_iw1 As long
    f11gby_iw2 As long
    f11gby_iwgt As long
    f11gby_ix As long
    f11gby_maxitn As long
    f11gby_maxits As long
    f11gby_monit As long
    f11gby_n As long
    f11gby_norm As long
    f11gby_resid As long
    f11gby_sigcmp As long
    f11gby_sigcmx As long
    f11gby_stage As long
    f11gby_floop as Nag_Boolean
    f11gby_next as Nag_Boolean
    f11gby_usexc as Nag_Boolean
    f11gby_precon as Nag_SparseSym_PrecType
    f11gbx_fpass as Nag_Boolean
    pad98 As long ' Pad to double-word boundary
    f11gbv_rho As double
    f11gbv_xi As double
    f11gbs_dov1 as Nag_Boolean
    pad101 As long ' Pad to double-word boundary
    f11gbr_deltab As double
    f11gbr_epslon As double
    f11baz_idatax (1 to 20) As long
    f11baz_rdatax (1 to 20) As double
    f11gbw_eps As double
    f11gbw_epslon As double
    f11gbw_mu1 As double
    f11gbw_mu1l As double
    f11gbw_mun As double
    f11gbw_munh As double
    f11gbw_sigmx0 As double
    f11gbw_sigmx1 As double
    f11gbw_sigtol As double
    f11gbw_ta2 As double
    f11gbw_tb2 As double
    f11gbw_tnorm As double
    f11gbw_maxits As long
    f11gbw_sigcmp as Nag_Boolean
    f11gbc_ifaill As long
    f11gbc_ifailm As long
    f11gbc_info As long
    f11gbc_irevcx As long
    f11gbc_kill As long
    f11gbc_idata (1 to 20) As long
    f11gbc_lworkl As long
    f11gbc_done as Nag_Boolean
    f11gbc_first as Nag_Boolean
    f11gbc_rdata (1 to 20) As double
    f11gbq_factol As double
    f11gbq_stprhx As double
    f11gbq_tolc As double
    f11gbq_toleps As double
    f11gbq_tolf As double
    f11gbq_toll As double
    f11gbq_xcbnrm As double
    f11gbq_xlbnrm As double
    f11gbq_xnorm As double
    f11gbq_loop As long
    f11gbq_fterm as Nag_Boolean
    f11gbu_epslon As double
    f11gbu_stprhx As double
    f11gbu_toleps As double
    f11gbu_tolf As double
    f11gbu_xnorm0 As double
    f11gbu_loop As long
    f11gbu_nrestl As long
    f11gbu_nrestc As long
    f11gbu_fterm as Nag_Boolean
    f11bbz_iwgt As long
    f11bbz_norm As long
    f11bbz_iterm As long
    f11bbz_monit As long
    f11bbz_m As long
    f11bbz_n As long
    f11bbz_stage As long
    f11bbz_ib As long
    f11bbz_ic As long
    f11bbz_ih As long
    f11bbz_iq As long
    f11bbz_ir As long
    f11bbz_is As long
    f11bbz_it As long
    f11bbz_ix As long
    f11bbz_infoch As long
    f11bbz_imonit As long
    f11bbz_maxitn As long
    f11bbz_itn As long
    pad168 As long ' Pad to double-word boundary
    f11bbz_anorm As double
    f11bbz_bnorm As double
    f11bbz_rnrm20 As double
    f11bbz_xnorm As double
    f11bbz_rnorm2 As double
    f11bbz_xnorm2 As double
    f11bbz_sigmax As double
    f11bbz_stplhs As double
    f11bbz_stprhs As double
    f11bbz_tol As double
    f11bbz_anrcmp as Nag_Boolean
    f11bbz_precon as Nag_Boolean
    f11bbz_next as Nag_Boolean
    f11bbz_fcall as Nag_Boolean
    f11bbu_first as Nag_Boolean
    f11bbu_usedot as Nag_Boolean
    f11bbv_tolf As double
    f11bbr_alpha As double
    f11bbr_rho As double
    f11bbr_do1 as Nag_Boolean
    pad188 As long ' Pad to double-word boundary
    f11bbw_stpr As double
    f11bbw_m1 As long
    pad190 As long ' Pad to double-word boundary
    f11bbw_tnorm As double
    f11bbw_im As long
    f11bbw_sigcmp as Nag_Boolean
    f11bbw_im1 As long
    pad194 As long ' Pad to double-word boundary
    f11bbw_tinorm As double
    f11bbw_restrt as Nag_Boolean
    pad196 As long ' Pad to double-word boundary
    f11bbw_tol1 As double
    f11bbt_iwgt As long
    f11bbt_norm As long
    f11bbt_next as Nag_Boolean
    f11bbt_n As long
    f11bbt_fcall as Nag_Boolean
    f11bbt_irbar As long
    f11bbt_stage As long
    pad204 As long ' Pad to double-word boundary
    f11bbt_anorm As double
    f11bbt_bnorm As double
    f11bbt_iterm As long
    f11bbt_monit As long
    f11bbt_xnorm As double
    f11bbt_ib As long
    f11bbt_ip As long
    f11bbt_ir As long
    f11bbt_it As long
    f11bbt_ix As long
    f11bbt_iy As long
    f11bbt_infoch As long
    f11bbt_anrcmp as Nag_Boolean
    f11bbt_precon as Nag_Boolean
    pad218 As long ' Pad to double-word boundary
    f11bbt_sigmax As double
    f11bbt_maxitn As long
    pad220 As long ' Pad to double-word boundary
    f11bbt_stplhs As double
    f11bbt_stprhs As double
    f11bbt_restrt as Nag_Boolean
    f11bbt_itn As long
    f11bbt_tol As double
    f11bbq_tolf As double
    f11bbq_loop As long
    f11bbq_pass1 as Nag_Boolean
    f11bbq_frest as Nag_Boolean
    pad229 As long ' Pad to double-word boundary
    f11bbq_xnmax As double
    f11bbq_toleps As double
    f11bbq_stplhx As double
    f11bbq_stprhx As double
    f11bbq_zz1 As double
    f11bbq_zz2 As double
    f11bbp_doxn as Nag_Boolean
    f11bbp_next as Nag_Boolean
    f11bbp_fcall as Nag_Boolean
    f11bbp_anrcmp as Nag_Boolean
    f11bbp_finish as Nag_Boolean
    f11bbp_precon as Nag_Boolean
    f11bbp_restrt as Nag_Boolean
    f11bbp_imonit As long
    f11bbp_maxitn As long
    f11bbp_igam As long
    f11bbp_itau As long
    f11bbp_iwgt As long
    f11bbp_norm As long
    f11bbp_m As long
    f11bbp_n As long
    f11bbp_igamp As long
    f11bbp_irbar As long
    f11bbp_stage As long
    f11bbp_xnorm As double
    f11bbp_anorm As double
    f11bbp_bnorm As double
    f11bbp_iterm As long
    f11bbp_monit As long
    f11bbp_ib As long
    f11bbp_iq As long
    f11bbp_ir As long
    f11bbp_ix As long
    f11bbp_infoch As long
    f11bbp_idx As long
    f11bbp_itn As long
    f11bbp_ipx As long
    f11bbp_sigmax As double
    f11bbp_stplhs As double
    f11bbp_stprhs As double
    f11bbp_tol As double
    f11bbn_rhox As double
    f11bbn_alpha As double
    f11bbn_tol1 As double
    f11bbn_tol2 As double
    f11bbn_rn1 As double
    f11bbn_i1 As long
    f11bbn_j1 As long
    f11bbn_n1 As long
    f11bbn_im As long
    f11bbn_jn1 As long
    f11bbn_imn As long
    f11bbn_doq as Nag_Boolean
    pad282 As long ' Pad to double-word boundary
    f11bbm_tolf As double
    f11bbm_jitn As long
    f11bbm_kitn As long
    f11bbm_loop As long
    f11bbm_pass1 as Nag_Boolean
    f11bbm_frest as Nag_Boolean
    f11bbm_irest As long
    f11bbm_xnmax As double
    f11bbm_toleps As double
    f11bbm_stplhx As double
    f11bbm_stprhx As double
    f11bbm_zz1 As double
    f11bbm_zz2 As double
    f11bbf_irevcx As long
    f11bbf_done as Nag_Boolean
    f11bbf_first as Nag_Boolean
    f11bbf_info As long
    f11bbf_kill As long
    f11bbf_idata (1 to 20) As long
    f11bbf_rdata (1 to 20) As double
    f11bbf_ifaill As long
    f11bbf_ifailm As long
    f11bbf_lworkl As long
End Type



Type NagError
    code As long
    dnprint as Nag_Boolean
    message (1 to NAG_ERROR_BUF_LEN) As byte
    handler As Long
    errnum As long
    iflag As long
    ival As long
End Type



Type Nag_User
    p As Long
End Type



Type Nag_Comm
    flag As long
    first as Nag_Boolean
    last as Nag_Boolean
    nf As long
    it_prt as Nag_Boolean
    it_maj_prt as Nag_Boolean
    sol_sqp_prt as Nag_Boolean
    sol_prt as Nag_Boolean
    rootnode_sol_prt as Nag_Boolean
    node_prt as Nag_Boolean
    rootnode_prt as Nag_Boolean
    g_prt as Nag_Boolean
    new_lm as Nag_Boolean
    needf As long
    p As Long
    iuser As Long ' pointer to long
    user As Long ' pointer to double
    nag_w As Long ' pointer to double
    nag_iw As Long ' pointer to long
    nag_p As Long
    nag_print_w As Long ' pointer to double
    nag_print_iw As Long ' pointer to long
    nrealloc As long
End Type



Type Nag_QuadProgress
    num_subint As long
    fun_count As long
    sub_int_beg_pts As Long ' pointer to double
    sub_int_end_pts As Long ' pointer to double
    sub_int_result As Long ' pointer to double
    sub_int_error As Long ' pointer to double
End Type



Type Nag_QuadSubProgress
    intervals As long
    fun_count As long
    subints_per_interval As long
    interval_error As Long ' pointer to double
    interval_result As Long ' pointer to double
    interval_flag As Long ' pointer to long
End Type



Type Nag_ad02
    alpha (1 to 12) As double
    beta (1 to 12) As double
    psi (1 to 12) As double
    v (1 to 12) As double
    w (1 to 12) As double
    sig (1 to 13) As double
    g (1 to 13) As double
    gi (1 to 11) As double
    xold As double
    hold As double
    told As double
    xsave As double
    tstar As double
    twou As double
    init As long
    ibegin As long
    itol As long
    iinteg As long
    itstop As long
    inflop As long
    iquit As long
    iv (1 to 10) As long
    ns As long
    kord As long
    kold As long
    ksteps As long
    kle4 As long
    kprev As long
    ivc As long
    kgi As long
    start as Nag_Boolean
    phase1 as Nag_Boolean
    nornd as Nag_Boolean
    stiff as Nag_Boolean
    intout as Nag_Boolean
End Type



Type Nag_bd02
    zero As double
    u As double
    fouru As double
    sru As double
    u34 As double
    u78 As double
    srbig As double
    delsgn As double
    troots As double
    tleft As double
    svtnew As double
    krootp As long
    inrotp As long
    gstop as Nag_Boolean
    pgstop as Nag_Boolean
    root as Nag_Boolean
    roots as Nag_Boolean
    needg as Nag_Boolean
    discop as Nag_Boolean
    newgeq as Nag_Boolean
    search as Nag_Boolean
    pserch as Nag_Boolean
End Type



Type Nag_dd02
    ts As double
    gts As double
    fd As double
    ftd As double
    fm As double
    fmx As double
    prev As double
    min As double
    max As double
    avg As double
    amb As double
    ambs As double
    sbma As double
    sf As double
    dezu34 As double
    ic As long
    kmc As long
    ising As long
    kount As long
    ktest As long
    locext as Nag_Boolean
End Type



Type Nag_ed02
    aez As double
    agtrl As double
    at As double
    atm As double
    atmtr As double
    brd As double
    brds As double
    ddt As double
    deltg As double
    deltgm As double
    deltr As double
    dg As double
    dtg As double
    dtgk As double
    dtgp As double
    dtqr As double
    fac As double
    g21 As double
    g32 As double
    gat As double
    gbr As double
    gbrc As double
    gbrmin As double
    gbrmns As double
    gct As double
    glocmx As double
    gmsign As double
    goldsv As double
    got As double
    gres As double
    gright As double
    gt21 As double
    gt32 As double
    gtint As double
    gtqr As double
    gtrl As double
    gtt As double
    gttmr As double
    gvalue As double
    gvdif As double
    gvmax As double
    gvmin As double
    omu78 As double
    opu78 As double
    pu As double
    qc0 As double
    qc1 As double
    qc2 As double
    qd As double
    qdq As double
    qr1 As double
    qr1n As double
    qr1p As double
    quadmn As double
    rd As double
    rdg As double
    dnrem As double
    remd As double
    rez As double
    rootno As double
    sdg As double
    signg As double
    slope1 As double
    slope2 As double
    slopep As double
    sotgv As double
    ss As double
    sstu78 As double
    t21 As double
    t31 As double
    t32 As double
    taddon As double
    tcb As double
    tcf As double
    tclose As double
    tdif As double
    tdmn As double
    tdmx As double
    tfar As double
    tgbrmn As double
    tgvdif As double
    tgvmt As double
    tint As double
    tintp As double
    tk As double
    tkold As double
    tlbk As double
    tnew As double
    tp As double
    tpoint As double
    tprev As double
    tqr As double
    tqr1 As double
    tqr2 As double
    tqrf As double
    tqrmp As double
    tqrp As double
    tqs As double
    tqt As double
    trd As double
    trj As double
    trl As double
    trn As double
    trnow As double
    troot As double
    tsave As double
    tslop As double
    tsru As double
    tstep As double
    tt As double
    tu78 As double
    tut As double
    tz As double
    tzero As double
    tzerok As double
    tzj As double
    tzk As double
    grno As double
    gt As double
    sttu78 As double
    tadd (1 to 2) As double
    tr (1 to 3) As double
End Type



Type Nag_fd02
    backr as Nag_Boolean
    mroot as Nag_Boolean
    multr as Nag_Boolean
    peak as Nag_Boolean
    qrreal as Nag_Boolean
    skpmmt as Nag_Boolean
End Type



Type Nag_gd02
    i As long
    i1 As long
    i2 As long
    i21 As long
    i3 As long
    iadd As long
    ic1 As long
    ic2 As long
    icase As long
    icbr As long
    icbrk As long
    idtg As long
    iga As long
    ijk As long
    ik As long
    ikmr As long
    iktqr As long
    indx As long
    isi As long
    isin As long
    isr As long
    itgvt As long
    itry As long
    j As long
    j1 As long
    j2 As long
    j23 As long
    j3 As long
    jp1 As long
    jr As long
    jsr As long
    k As long
    kge As long
    kp1 As long
    krootn As long
    krooto As long
    kroots As long
    kskpmt As long
    ktry As long
    l As long
    ltqbig As long
    ltr As long
    mmr As long
    mmrin As long
    mmrk As long
    nsr As long
    ntin As long
    ntinm As long
    ipath As long
End Type



Type Nag_jd02
    a As double
    absdx As double
    da As double
    delx As double
    dfdub As double
    dfdxb As double
    dx As double
    fbnd As double
    power As double
    relper As double
    ynorm As double
    ypnorm As double
    icase As long
    k As long
    lk As long
End Type



Type Nag_kd02
    two (1 to 13) As double
    gstr (1 to 13) As double
    absh As double
    big As double
    erk As double
    erkm1 As double
    p5eps As double
    round As double
    u As double
    ifail As long
    km1 As long
    km2 As long
    knew As long
    kp1 As long
    kp2 As long
End Type



Type Nag_ODE_Adams
    init1 As long
    init2 As long
    neqf As long
    neqg As long
    state as Nag_Start
    alter_g as Nag_Boolean
    sophist as Nag_Boolean
    vectol as Nag_Boolean
    a_tol As Long ' pointer to double
    rtol As Long ' pointer to double
    crit as Nag_Boolean
    pad11 As long ' Pad to double-word boundary
    tcrit As double
    one_step as Nag_Boolean
    pad13 As long ' Pad to double-word boundary
    hmax As double
    max_step As long
    root as Nag_Boolean
    badcmp As long
    pad17 As long ' Pad to double-word boundary
    hnext As double
    hlast As double
    tolfac As double
    tcurr As double
    nsuccess As long
    nfail As long
    ord_last As long
    ord_next As long
    events As Long ' pointer to long
    resids As Long ' pointer to double
    yp As Long ' pointer to double
    yy As Long ' pointer to double
    p As Long ' pointer to double
    phi As Long ' pointer to double
    qwc_state As long
    qfc_state As long
    giwork As Long ' pointer to long
    siwork As Long ' pointer to long
    w As Long ' pointer to double
    gwork As Long ' pointer to double
    swork As Long ' pointer to double
    free As Long
    index As long
    type As long
    ad02qf as Nag_ad02
    bd02qf as Nag_bd02
    crash as Nag_Boolean
    izflag As long
    dd02qf as Nag_dd02
    ed02qf as Nag_ed02
    fd02qf as Nag_fd02
    gd02qf as Nag_gd02
    kroo As long
    jd02qf as Nag_jd02
    kd02qf as Nag_kd02
End Type



Type Nag_D03_Save
    cwsav (1 to 810) As byte
    rwsav (1 to 1100) As double
    iwsav (1 to 505) As long
    lwsav (1 to 100) As long
End Type



Type Nag_Spline
    n As long
    lamda As Long ' pointer to double
    c As Long ' pointer to double
    init1 As long
    init2 As long
End Type



Type Nag_2dSpline
    nx As long
    lamda As Long ' pointer to double
    ny As long
    mu As Long ' pointer to double
    c As Long ' pointer to double
    init1 As long
    init2 As long
End Type



Type Nag_Grad_Chk_St
    type as Nag_GradChk
    obj_start As long
    obj_stop As long
    con_start As long
    con_stop As long
    g_error As long
End Type



Type Nag_SimSt
    n_elements As long
    pad1 As long ' Pad to double-word boundary
    dir_deriv As double
    fd_approx As double
    correct as Nag_Boolean
    pad4 As long ' Pad to double-word boundary
    max_error As double
    max_subfunction As long
    max_constraint As long
End Type



Type Nag_CompSt
    assigned as Nag_Boolean
    pad1 As long ' Pad to double-word boundary
    hopt As double
    gdiff As double
    iter As long
    correct as Nag_Boolean
    comment As Long ' pointer to const char
    zero as Nag_Boolean
    dnerror As double
End Type



Type Nag_FDIntSt
    hfd As double
    hcd As double
    errmax As double
End Type



Type Nag_GPrintSt
    g_chk as Nag_Grad_Chk_St
    nfdiff As long
    ncdiff As long
    nf_const As long
    nc_const As long
    deriv_level as Nag_DerivSet
    old_deriv_level as Nag_DerivSet
    f_sim as Nag_SimSt
    c_sim as Nag_SimSt
    f_comp As Long ' pointer to Nag_CompSt
    c_comp As Long ' pointer to Nag_CompSt
    intervals As Long ' pointer to Nag_FDIntSt
    print_deriv as Nag_DPrintType
End Type



Type Nag_Search_State
    m As long
    n As long
    numinf As long
    x As Long ' pointer to double
    f As double
    objf As double
    g As Long ' pointer to double
    diagt As Long ' pointer to double
    fvec As Long ' pointer to double
    fjac As Long ' pointer to double
    conjac As Long ' pointer to double
    tdj As long
    tdconjac As long
    pad13 As long ' Pad to double-word boundary
    dnstep As double
    xk_norm As double
    gpj_norm As double
    cond As double
    cond_h As double
    cond_hz As double
    cond_t As double
    cond_r As double
    iter_conv as Nag_Boolean
    norm_gz_small as Nag_Boolean
    violtn_small as Nag_Boolean
    update_modified as Nag_Boolean
    c_diff as Nag_Boolean
    qp_not_feasible as Nag_Boolean
    step_limit_exceeded as Nag_Boolean
    refactor as Nag_Boolean
    mgrmsg As Long ' pointer to char
    pad30 As long ' Pad to double-word boundary
    norm_nlnviol As double
    grade As long
    s As Long ' pointer to double
    state As Long ' pointer to long
    iter As long
    major_iter As long
    minor_iter As long
    nfun As long
    pad38 As long ' Pad to double-word boundary
    merit As double
    violtn As double
    penalty As double
    itn As long
    nf As long
    nctotal As long
    lncons_val As Long ' pointer to double
    major_iter_soln as Nag_Boolean
    local_search as Nag_Boolean
    nclin As long
    ncnlin As long
    nactiv As long
    jdel As long
    jadd As long
    ninf As long
    sum_infeasibilities As double
    bnd As long
    lin As long
    nln As long
    t As Long ' pointer to double
    tdt As long
    r As Long ' pointer to double
    diagr As Long ' pointer to double
    tdr As long
    nart As long
    nartm As long
    nrz As long
    nz As long
    norm_gz As double
    norm_gf As double
    nopt As long
    pad69 As long ' Pad to double-word boundary
    min_lm As double
    condt As double
    condr As double
    rzz As double
    rset as Nag_Boolean
    ax As Long ' pointer to double
    cx As Long ' pointer to double
    nrank As long
    nfixed As long
    kx As Long ' pointer to long
    kactive As Long ' pointer to long
    lambda As Long ' pointer to double
    bclambda As Long ' pointer to double
    gq As Long ' pointer to double
    jmax As long
    pad84 As long ' Pad to double-word boundary
    errmax As double
    moved as Nag_Boolean
    nmoved As long
    feasible as Nag_Boolean
    rowerr as Nag_Boolean
    first as Nag_Boolean
    bl As Long ' pointer to double
    bu As Long ' pointer to double
    endstate as Nag_EndState
    gprint As Long ' pointer to Nag_GPrintSt
    pad94 As long ' Pad to double-word boundary
    fmin As double
    fmax As double
    simplex As Long ' pointer to double
    prbtyp As Long ' pointer to const char
    tdfjac As long
    col as Nag_Boolean
    index As long
    dnname As Long ' pointer to const char
    key As Long ' pointer to const char
    sstate As Long ' pointer to char
    val As double
    blo As double
    bup As double
    lmult As double
    objg As double
    just_feas as Nag_Boolean
    qp as Nag_Boolean
    pprice As long
    pad112 As long ' Pad to double-word boundary
    rgval As double
    sb_add As long
    sb_leave As long
    b_leave As long
    bswap_leave As long
    pivot As double
    nnz_l As long
    nnz_u As long
    ncp As long
    pad121 As long ' Pad to double-word boundary
    norm_rg As double
    nsb As long
    root as Nag_Boolean
    nnodes As long
    node_num As long
    parent_node As long
    crnames As Long ' pointer to char
    node_status as Nag_NodeStatus
    branch_index As long
    x_before As double
    x_after As double
    x_lo As double
    x_up As double
    depth As long
    posdef as Nag_Boolean
End Type



Type Nag_E04_Opt
    f_name As Long ' pointer to const char
    f_longname As Long ' pointer to const char
    init1 As long
    init2 As long
    minlin as Nag_LinFun
    grade As long
    nf As long
    iter As long
    major_iter As long
    max_iter As long
    minor_max_iter As long
    min_infeas as Nag_Boolean
    f_est As double
    step_max As double
    step_limit As double
    max_line_step As double
    f_prec As double
    linesearch_tol As double
    optim_tol As double
    conf As Long ' pointer to double
    nag_conf As long
    conjac As Long ' pointer to double
    nag_conjac As long
    h As Long ' pointer to double
    nag_h As long
    h_unit_init as Nag_Boolean
    h_reset_freq As long
    s As Long ' pointer to double
    nag_s As long
    v As Long ' pointer to double
    nag_v As long
    tdv As long
    delta As Long ' pointer to double
    nag_delta As long
    hesl As Long ' pointer to double
    nag_hesl As long
    hesd As Long ' pointer to double
    nag_hesd As long
    state As Long ' pointer to long
    nag_state As long
    init_state as Nag_InitType
    obj_deriv as Nag_Boolean
    con_deriv as Nag_Boolean
    f_diff_int As double
    c_diff_int As double
    obj_check_start As long
    obj_check_stop As long
    con_check_start As long
    con_check_stop As long
    verify_grad as Nag_GradChk
    hessian as Nag_Boolean
    local_search as Nag_Boolean
    deriv_check as Nag_Boolean
    list as Nag_Boolean
    print_gcheck as Nag_Boolean
    print_deriv as Nag_DPrintType
    print_level as Nag_PrintType
    minor_print_level as Nag_PrintType
    print_iter As long
    outfile (1 to NAG_FILE_LEN) As byte
    print_fun As Long
    ax As Long ' pointer to double
    nag_ax As long
    lambda As Long ' pointer to double
    nag_lambda As long
    fcheck As long
    crash_tol As double
    reset_ftol As long
    fmax_iter As long
    ftol As double
    lin_feas_tol As double
    nonlin_feas_tol As double
    hrows As long
    pad73 As long ' Pad to double-word boundary
    inf_bound As double
    inf_step As double
    max_df As long
    prob as Nag_ProblemType
    rank_tol As double
    form_hessian as Nag_Boolean
    start as Nag_Start
    debug_iter As long
    minor_debug_iter As long
    dbug as Nag_Boolean
    used as Nag_Boolean
    unitq as Nag_Boolean
    nfree As long
    nactiv As long
    nprob As long
    n As long
    nclin As long
    ncnlin As long
    pad91 As long ' Pad to double-word boundary
    bndlow As double
    bndupp As double
    minimize as Nag_Boolean
    factor_freq As long
    partial_price As long
    max_sb As long
    lu_factor_tol As double
    lu_sing_tol As double
    lu_update_tol As double
    pivot_tol As double
    scale_tol As double
    crash as Nag_CrashType
    dnscale as Nag_ScaleType
    prob_name (1 to MPS_NAME_LEN+1) As byte
    obj_name (1 to MPS_NAME_LEN+1) As byte
    bnd_name (1 to MPS_NAME_LEN+1) As byte
    rhs_name (1 to MPS_NAME_LEN+1) As byte
    range_name (1 to MPS_NAME_LEN+1) As byte
    crnames As Long ' pointer to char
    nag_crnames As long
    nsb As long
    max_restart As long
    max_basis_len As long
    max_compress As long
    max_basis_nfactor As long
    pad116 As long ' Pad to double-word boundary
    col_lo_default As double
    col_up_default As double
    infinity As double
    ncol_approx As long
    nrow_approx As long
    est_density As double
    output_level as Nag_OutputType
    deriv_want as Nag_DWantType
    use_hfwd_init as Nag_Boolean
    pad125 As long ' Pad to double-word boundary
    f_prec_used As double
    print_80ch as Nag_Boolean
    feas_exit as Nag_Boolean
    hess_freq As long
    pad129 As long ' Pad to double-word boundary
    elastic_wt As double
    lu_den_tol As double
    part_price As long
    scale_opt As long
    expand_freq As long
    hess_update As long
    iter_lim As long
    pad136 As long ' Pad to double-word boundary
    major_opt_tol As double
    minor_opt_tol As double
    unbounded_obj As double
    major_step_lim As double
    major_iter_lim As long
    pad141 As long ' Pad to double-word boundary
    major_feas_tol As double
    minor_iter_lim As long
    pad143 As long ' Pad to double-word boundary
    minor_feas_tol As double
    violation_limit As double
    nz_coef As double
    deriv_linesearch as Nag_Boolean
    hess_storage as Nag_HessianType
    direction as Nag_DirectionType
    ncon As long
End Type



Type Nag_E04State
    cw (1 to 600*8) As byte
    iw (1 to 600) As long
    rw (1 to 600) As double
End Type



Type Nag_E05State
    comm (1 to 100) As double
End Type



Type Nag_UserPrintFun
    itc As long
    pad1 As long ' Pad to double-word boundary
    rss As double
    objf As double
    para As Long ' pointer to double
    sd As Long ' pointer to double
    df As double
    npara As long
    npe As long
    mtyp As Long ' pointer to long
    mser As Long ' pointer to long
End Type



Type Nag_G13_Opt
    used as Nag_Boolean
    f_name As Long ' pointer to const char
    init1 As long
    init2 As long
    cfixed as Nag_Boolean
    criteria as Nag_Likelihood
    max_iter As long
    pad7 As long ' Pad to double-word boundary
    alpha As double
    beta As double
    delta As double
    gamma As double
    iter As long
    cm As Long ' pointer to double
    tdcm As long
    nag_cm As long
    res As Long ' pointer to double
    lenres As long
    nag_res As long
    zt As Long ' pointer to double
    tdzt As long
    nag_zt As long
    noise As Long ' pointer to double
    nag_noise As long
    isttf As long
    sttf As Long ' pointer to double
    nag_sttf As long
    nsttf As long
    print_level as Nag_PrintType
    list as Nag_Boolean
    print_fun As Long
    outfile (1 to NAG_FILE_LEN) As byte
End Type



Type Nag_ArimaOrder
    p As long
    d As long
    q As long
    bigp As long
    bigd As long
    bigq As long
    s As long
End Type



Type Nag_TransfOrder
    init3 As long
    b As Long ' pointer to long
    nag_b As long
    q As Long ' pointer to long
    nag_q As long
    p As Long ' pointer to long
    nag_p As long
    r As Long ' pointer to long
    nag_r As long
End Type



Type Nag_H02_Opt
    f_name As Long ' pointer to const char
    f_longname As Long ' pointer to const char
    prob as Nag_MIP_ProbType
    init1 As long
    init2 As long
    used as Nag_Boolean
    list as Nag_Boolean
    print_level as Nag_PrintType
    print_fun As Long
    outfile (1 to NAG_FILE_LEN) As byte
    max_iter As long
    inf_bound As double
    feas_tol As double
    hrows As long
    max_df As long
    rank_tol As double
    first_soln as Nag_Boolean
    max_depth As long
    max_nodes As long
    pad19 As long ' Pad to double-word boundary
    int_obj_bound As double
    soln_tol As double
    int_tol As double
    nodsel as Nag_Node_Selection
    varsel as Nag_Var_Selection
    branch_dir as Nag_Branch_Direction
    priority As Long ' pointer to double
    lower As Long ' pointer to double
    upper As Long ' pointer to double
    lambda As Long ' pointer to double
    state As Long ' pointer to long
    nag_lower As long
    nag_upper As long
    nag_state As long
    nag_lambda As long
    prob_name (1 to MPS_NAME_LEN+1) As byte
    obj_name (1 to MPS_NAME_LEN+1) As byte
    bnd_name (1 to MPS_NAME_LEN+1) As byte
    rhs_name (1 to MPS_NAME_LEN+1) As byte
    range_name (1 to MPS_NAME_LEN+1) As byte
    crnames As Long ' pointer to char
    nag_crnames As long
    col_lo_default As double
    col_up_default As double
    infinity As double
    ncol_approx As long
    nrow_approx As long
    output_level as Nag_OutputType
    n_ivar As long
    dbg as Nag_Boolean
    dbg_rt as Nag_Boolean
    dbg_rqip as Nag_Boolean
    dbg_es as Nag_EndState
End Type



' end of type declarations


' enumeration type declations


Public Enum NagMeanOrTrend
  Nag_NoCorrection=1538
  Nag_Mean=1539
  Nag_Trend=1540
End Enum


Public Enum Nag_BalanceType
  Nag_NoBalancing=2020
  Nag_BalancePermute=2021
  Nag_BalanceScale=2022
  Nag_BalanceBoth=2023
End Enum


Public Enum Nag_Barrier
  Nag_DownandIn=2200
  Nag_DownandOut=2201
  Nag_UpandIn=2202
  Nag_UpandOut=2203
End Enum


Public Enum Nag_BaseRNG
  Nag_Basic=2150
  Nag_WichmannHill_I=2151
  Nag_MersenneTwister=2152
  Nag_WichmannHill_II=2153
  Nag_ACORN=2154
  Nag_MRG32k3a=2155
End Enum


Public Enum Nag_Blocks
  Nag_NoBlocks=1454
  Nag_SerialBlocks=1455
  Nag_ParallelBlocks=1456
End Enum


Public Enum Nag_Boolean
  Nag_FALSE=0
  Nag_TRUE=1
End Enum


Public Enum Nag_BoundInterval
  Nag_UpperSemiInfinite=1076
  Nag_LowerSemiInfinite=1077
  Nag_Infinite=1078
End Enum


Public Enum Nag_BoundType
  Nag_BoundNotSet=1181
  Nag_Bounds=1182
  Nag_BoundsZero=1183
  Nag_BoundsEqual=1184
  Nag_NoBounds=1185
  Nag_NoBounds_One_Call=1186
End Enum


Public Enum Nag_Branch_Direction
  Nag_BrDir_NotSet=1586
  Nag_Branch_Left=1587
  Nag_Branch_Right=1588
  Nag_Branch_InitX=1589
End Enum


Public Enum Nag_BridgeOrder
  Nag_LRRoundDown=1
  Nag_LRRoundUp=2
  Nag_RLRoundDown=3
  Nag_RLRoundUp=4
End Enum


Public Enum Nag_CEMethod
  Nag_CE_EM=1475
  Nag_CE_NR=1476
End Enum


Public Enum Nag_CallPut
  Nag_Call=2190
  Nag_Put=2191
End Enum


Public Enum Nag_CestMethod
  Nag_Censored=1477
  Nag_NoCensored=1478
End Enum


Public Enum Nag_ClassBoundary
  Nag_ClassBoundaryUser=1346
  Nag_ClassBoundaryComp=1347
End Enum


Public Enum Nag_ClusterMethod
  Nag_SingleLink=1440
  Nag_CompleteLink=1441
  Nag_GroupAverage=1442
  Nag_Centroid=1443
  Nag_Median=1444
  Nag_MinVariance=1445
End Enum


Public Enum Nag_ColumnPermutationType
  Nag_Sparse_Identity=2120
  Nag_Sparse_User=2121
  Nag_Sparse_Colamd=2122
End Enum


Public Enum Nag_CompProb
  Nag_CompProbExact=1467
  Nag_CompProbApprox=1468
End Enum


Public Enum Nag_ComplexFormType
  Nag_AboveForm=1609
  Nag_BracketForm=1610
  Nag_DirectForm=1611
End Enum


Public Enum Nag_ComputeEigVecsType
  Nag_NotEigVecs=2040
  Nag_TridiagEigVecs=2041
  Nag_OrigEigVecs=2042
End Enum


Public Enum Nag_ComputeQType
  Nag_InitQ=1027
  Nag_NotQ=1028
  Nag_AccumulateQ=1029
  Nag_UpdateSchur=1030
End Enum


Public Enum Nag_ComputeSingularVecsType
  Nag_NotSingularVecs=2030
  Nag_PackedSingularVecs=2031
  Nag_SingularVecs=2032
End Enum


Public Enum Nag_ComputeType
  Nag_Compute_Definite=500046
  Nag_Compute_Definite_Indefinite=1066
  Nag_Compute_Indefinite=1067
End Enum


Public Enum Nag_ComputeUType
  Nag_AllU=2060
  Nag_NotU=2061
End Enum


Public Enum Nag_ComputeVTType
  Nag_NotVT=2100
  Nag_AllVT=2101
End Enum


Public Enum Nag_ComputeVType
  Nag_ComputeV=2070
  Nag_NotV=2071
  Nag_InitV=2072
End Enum


Public Enum Nag_ComputeZType
  Nag_InitZ=1031
  Nag_NotZ=1032
  Nag_AccumulateZ=1033
  Nag_UpdateZ=1034
End Enum


Public Enum Nag_CondErrType
  Nag_NoCondBackErr=3040
  Nag_CondOnly=3041
  Nag_BackErrLeft=3042
  Nag_BackErrRight=3043
  Nag_BackErrBoth=3044
  Nag_CondBackErrLeft=3045
  Nag_CondBackErrRight=3046
  Nag_CondBackErrBoth=3047
End Enum


Public Enum Nag_ConjType
  Nag_Conj=191
  Nag_NoConj=192
End Enum


Public Enum Nag_ControllerForm
  Nag_UH_Controller=1553
  Nag_LH_Controller=1554
End Enum


Public Enum Nag_CovMatrixEst
  Nag_CovNotSet=1388
  Nag_CovMatAve=1389
  Nag_CovMatObs=1390
End Enum


Public Enum Nag_CovOrCorr
  Nag_AutoCov=1545
  Nag_AutoCorr=1546
End Enum


Public Enum Nag_CrashType
  Nag_CrashNotSet=1252
  Nag_NoCrash=1253
  Nag_CrashOnce=1254
  Nag_CrashTwice=1255
  Nag_CrashThreeTimes=1256
End Enum


Public Enum Nag_DPrintType
  Nag_D_NotSet=1146
  Nag_D_NoPrint=1147
  Nag_D_Print=1148
  Nag_D_Sum=1149
  Nag_D_Full=1150
  Nag_D_Dbg=1151
End Enum


Public Enum Nag_DWantType
  Nag_DWant_NotSet=1155
  Nag_Grad_HessDiag=1156
  Nag_HessFull=1157
  Nag_Grad_HessFull=1158
End Enum


Public Enum Nag_DataByObsOrVar
  Nag_DataByVar=3070
  Nag_DataByObs=3071
End Enum


Public Enum Nag_DendOrient
  Nag_DendNorth=1446
  Nag_DendSouth=1447
  Nag_DendEast=1448
  Nag_DendWest=1449
End Enum


Public Enum Nag_DerivInfo
  Nag_DInfo_NotSet=1159
  Nag_Deriv_OK=1160
  Nag_Fun_Constant=1161
  Nag_Fun_LinearOdd=1162
  Nag_2ndDeriv_Large=1163
  Nag_1stDeriv_Small=1164
End Enum


Public Enum Nag_DerivSet
  Nag_DerivNotSet=1165
  Nag_SomeG_SomeJ=1166
  Nag_AllG_SomeJ=1167
  Nag_SomeG_AllJ=1168
  Nag_AllG_AllJ=1169
End Enum


Public Enum Nag_DerivType
  Nag_LeftDerivs=1104
  Nag_RightDerivs=1105
End Enum


Public Enum Nag_DiagType
  Nag_NonRefDiag=130
  Nag_NonUnitDiag=131
  Nag_UnitDiag=132
End Enum


Public Enum Nag_DirectionType
  Nag_DirectionNotSet=1617
  Nag_Minimize=1618
  Nag_Maximize=1619
  Nag_FeasiblePoint=1620
End Enum


Public Enum Nag_DiscreteDistrib
  Nag_PDF=1469
  Nag_CDF=1470
End Enum


Public Enum Nag_DiscrimMethod
  Nag_DiscrimEstimate=1426
  Nag_DiscrimPredict=1427
End Enum


Public Enum Nag_DistanceType
  Nag_DistAbs=1433
  Nag_DistEuclid=1434
  Nag_DistSquared=1435
End Enum


Public Enum Nag_Distributions
  Nag_Uniform=1485
  Nag_Normal=1486
  Nag_Gamma=1487
  Nag_Beta=1488
  Nag_ChiSquare=1489
  Nag_Binomial=1490
  Nag_Exponential=1491
  Nag_Poisson=1492
  Nag_UserProb=1493
  Nag_LogNormal=1494
  Nag_StudentT=1495
  Nag_NegBinomial=500011
  Nag_GenPareto=500012
End Enum


Public Enum Nag_DummyType
  Nag_Poly=1457
  Nag_Helmert=1458
  Nag_FirstLevel=1459
  Nag_LastLevel=1460
  Nag_AllLevels=1461
End Enum


Public Enum Nag_EigValRankType
  Nag_ByBlock=1052
  Nag_Entire=1053
End Enum


Public Enum Nag_EigValsSourceType
  Nag_HSEQRSource=1035
  Nag_NotKnown=1036
End Enum


Public Enum Nag_Eigenvalues
  Nag_AllEigVals=1450
  Nag_LargeEigVals=1451
End Enum


Public Enum Nag_EmbedPad
  Nag_EmbedPadZeros=1
  Nag_EmbedPadValues=2
End Enum


Public Enum Nag_EmbedScale
  Nag_EmbedScaleTraces=1
  Nag_EmbedScaleSqrtTraces=2
  Nag_EmbedScaleOne=3
End Enum


Public Enum Nag_EndState
  Nag_EndStateNotSet=1206
  Nag_Feasible=1207
  Nag_Optimal=1208
  Nag_Deadpoint=1209
  Nag_Weakmin=1210
  Nag_Unbounded=1211
  Nag_Infeasible=1212
  Nag_Too_Many_Iter=1213
  Nag_Hess_Too_Big=1214
  Nag_Cycling=1215
  Nag_Not_Converged=1216
  Nag_Not_Kuhn_Tucker=1217
  Nag_Deriv_Error=1218
  Nag_Hess_Indefinite=1219
  Nag_Basis_Ill_Cond=1220
  Nag_Basis_Singular=1221
  Nag_Out_Of_Workspace=1222
  Nag_MIP_Best_ISol=1223
  Nag_MIP_Stop_First_ISol=1224
  Nag_MIP_No_ISol=1225
  Nag_MIP_Root_Unbounded=1226
  Nag_MIP_Root_Infeasible=1227
  Nag_MIP_Root_Max_Itn=1228
  Nag_MIP_Root_Big_Hess=1229
  Nag_MIP_Max_Itn_ISol=1230
  Nag_MIP_Max_Nodes_ISol=1231
  Nag_MIP_Big_Hess_ISol=1232
  Nag_MIP_Max_Depth_ISol=1233
  Nag_MIP_Big_Hess_No_ISol=1234
  Nag_MIP_Max_Itn_No_ISol=1235
  Nag_MIP_Max_Nodes_No_ISol=1236
  Nag_MIP_Max_Depth_No_ISol=1237
  Nag_MIP_User_Stop=1238
End Enum


Public Enum Nag_EquilibrationType
  Nag_NoEquilibration=2000
  Nag_Equilibrated=2001
  Nag_RowEquilibration=2002
  Nag_ColumnEquilibration=2003
  Nag_RowAndColumnEquilibration=2004
End Enum


Public Enum Nag_ErrorAssess
  Nag_ErrorAssess_off=1097
  Nag_ErrorAssess_on=1098
End Enum


Public Enum Nag_ErrorControl
  Nag_Relative=1087
  Nag_Absolute=1088
  Nag_Mixed=1089
  Nag_Default=1089
End Enum


Public Enum Nag_ErrorDistn
  Nag_NormalDistn=1481
  Nag_Tdistn=1482
End Enum


Public Enum Nag_EstimatesOption
  Nag_EstimatesOrig=2610
  Nag_EstimatesStand=2611
End Enum


Public Enum Nag_EvaluateJacobian
  Nag_NumericalJacobian=0
  Nag_AnalyticalJacobian=1
  Nag_DefaultJacobian=2
  Nag_AnalyticalStructJacobian=3
  Nag_NumericalStructJacobian=4
End Enum


Public Enum Nag_ExpSmoothType
  Nag_SingleExponential=2580
  Nag_BrownsExponential=2581
  Nag_LinearHolt=2582
  Nag_AdditiveHoltWinters=2583
  Nag_MultiplicativeHoltWinters=2584
End Enum


Public Enum Nag_FacMat
  Nag_DataCorr=1415
  Nag_DataCovar=1416
  Nag_MatCorr_Covar=1417
End Enum


Public Enum Nag_FacRotation
  Nag_FacRotate=1420
  Nag_FacNoRotate=1421
End Enum


Public Enum Nag_FacScoreMethod
  Nag_FacScoreRegsn=1418
  Nag_FacScoreBart=1419
End Enum


Public Enum Nag_FactoredFormType
  Nag_Factored=2010
  Nag_NotFactored=2011
  Nag_EquilibrateAndFactor=2012
End Enum


Public Enum Nag_FullStepwise
  Nag_AddVar=2140
  Nag_BeginBackward=2141
  Nag_ColinearVar=2142
  Nag_DropVar=2143
  Nag_BeginForward=2144
  Nag_NoRemoveVar=2145
  Nag_BeginStepwise=2146
  Nag_VarianceRatio=2147
  Nag_FinishStepwise=2148
End Enum


Public Enum Nag_FunType
  Nag_Deriv=1170
  Nag_NoDeriv=1171
  Nag_Function=1172
End Enum


Public Enum Nag_Garch_Est_Initial_Type
  Nag_Garch_Est_Initial_True=1561
  Nag_Garch_Est_Initial_False=1562
End Enum


Public Enum Nag_Garch_Stationary_Type
  Nag_Garch_Stationary_True=1559
  Nag_Garch_Stationary_False=1560
End Enum


Public Enum Nag_GaussFormulae
  Nag_Legendre=1081
  Nag_Rational=1082
  Nag_Laguerre=1083
  Nag_Hermite=1084
End Enum


Public Enum Nag_GradChk
  Nag_ChkNotSet=1136
  Nag_NoCheck=1137
  Nag_SimpleCheck=1138
  Nag_CheckObj=1139
  Nag_CheckCon=1140
  Nag_CheckObjCon=1141
  Nag_XSimpleCheck=1142
  Nag_XCheckObj=1143
  Nag_XCheckCon=1144
  Nag_XCheckObjCon=1145
End Enum


Public Enum Nag_GroupCovars
  Nag_EqualCovar=1422
  Nag_NotEqualCovar=1423
End Enum


Public Enum Nag_HessianType
  Nag_HessianNotSet=1614
  Nag_HessianFull=1615
  Nag_HessianLimited=1616
End Enum


Public Enum Nag_HowManyType
  Nag_ComputeAll=1037
  Nag_BackTransform=1038
  Nag_ComputeSelected=1039
End Enum


Public Enum Nag_IncSignZeros
  Nag_IncSignZerosY=1483
  Nag_IncSignZerosN=1484
End Enum


Public Enum Nag_IncludeIntercept
  Nag_Intercept=2840
  Nag_NoIntercept=2841
End Enum


Public Enum Nag_IncludeMean
  Nag_MeanInclude=1358
  Nag_MeanZero=1359
End Enum


Public Enum Nag_InitType
  Nag_InitNotSet=1176
  Nag_Init_None=1177
  Nag_Init_F_G_H=1178
  Nag_Init_All=1179
  Nag_Init_H_S=1180
End Enum


Public Enum Nag_InitVeenumtype
  Nag_NoVec=1040
  Nag_UserVec=1041
End Enum


Public Enum Nag_InitialValues
  Nag_InitialValuesSupplied=2172
  Nag_ContinueNoUpdate=2170
  Nag_ContinueAndUpdate=2171
End Enum


Public Enum Nag_InitializeA
  Nag_InitializeI=1471
  Nag_InputA=1472
End Enum


Public Enum Nag_IntervalType
  Nag_TukeyInterval=1462
  Nag_BonferroniInterval=1463
  Nag_DunnInterval=1464
  Nag_FisherInterval=1465
  Nag_ScheffeInterval=1466
End Enum


Public Enum Nag_JobType
  Nag_DoBoth=1044
  Nag_EigVals=1045
  Nag_DoNothing=1046
  Nag_Permute=1047
  Nag_Schur=1048
  Nag_Scale=1049
  Nag_Subspace=1050
  Nag_EigVecs=1051
End Enum


Public Enum Nag_KernelForm
  Nag_NoCentroSymm=2760
  Nag_CentroSymmOdd=2761
  Nag_CentroSymmEven=2762
  Nag_CentroSymmNeither=2763
End Enum


Public Enum Nag_LARSModelType
  Nag_LARS_LAR=4000
  Nag_LARS_ForwardStagewise=4001
  Nag_LARS_LASSO=4002
  Nag_LARS_PositiveLASSO=4003
End Enum


Public Enum Nag_LARSPreProcess
  Nag_LARS_None=4010
  Nag_LARS_Centered=4011
  Nag_LARS_Normalized=4012
  Nag_LARS_CenteredNormalized=4013
End Enum


Public Enum Nag_LARSTargetType
  Nag_LARS_StepNumber=4020
  Nag_LARS_ScaledNorm=4021
  Nag_LARS_ProportionScaledNorm=4022
  Nag_LARS_UnscaledNorm=4023
  Nag_LARS_ProportionUnscaledNorm=4024
End Enum


Public Enum Nag_LCCMethod
  Nag_LCCPan=1348
  Nag_LCCImhof=1349
  Nag_LCCDefault=1350
End Enum


Public Enum Nag_LabelType
  Nag_NoLabels=1603
  Nag_longLabels=1604
  Nag_CharacterLabels=1605
End Enum


Public Enum Nag_LeftVecsType
  Nag_LeftVecs=2080
  Nag_NotLeftVecs=2081
  Nag_LeftSpan=2082
  Nag_NotLeftWork=2083
  Nag_LeftVecsCtol=2084
End Enum


Public Enum Nag_Likelihood
  Nag_CriteriaNotSet=1530
  Nag_LeastSquares=1531
  Nag_Exact=1532
  Nag_Marginal=1533
End Enum


Public Enum Nag_LinAlgOption
  Nag_LinAlgFull=1119
  Nag_LinAlgBand=1120
  Nag_LinAlgSparse=1121
End Enum


Public Enum Nag_LinFun
  Nag_LinFunNotSet=1173
  Nag_Lin_Deriv=1174
  Nag_Lin_NoDeriv=1175
End Enum


Public Enum Nag_Link
  Nag_Expo=1366
  Nag_Iden=1367
  Nag_Log=1368
  Nag_Sqrt=1369
  Nag_Reci=1370
  Nag_Logistic=1371
  Nag_Probit=1372
  Nag_Compl=1373
End Enum


Public Enum Nag_LoggedSpectra
  Nag_Unlogged=1541
  Nag_Logged=1542
End Enum


Public Enum Nag_MCMethod
  Nag_OneIteration=1085
  Nag_ManyIterations=1086
End Enum


Public Enum Nag_MCSInitMethod
  Nag_SimpleBdry=2670
  Nag_SimpleOffBdry=2671
  Nag_Linesearch=2672
  Nag_UserSet=2673
  Nag_Random=2674
End Enum


Public Enum Nag_MIP_ProbType
  Nag_MIP_TypeNotSet=1570
  Nag_MILP=1571
  Nag_MIQP1=1572
  Nag_MIQP2=1573
  Nag_MIQP3=1574
  Nag_MIQP4=1575
End Enum


Public Enum Nag_MahalDist
  Nag_SamplePoints=1424
  Nag_GroupMeans=1425
End Enum


Public Enum Nag_MatFunType
  Nag_Exp=2830
  Nag_Sin=2831
  Nag_Cos=2832
  Nag_Sinh=2833
  Nag_Cosh=2834
  Nag_Loga=2835
End Enum


Public Enum Nag_MatUpdate
  Nag_MatUp=1431
  Nag_NoMatUp=1432
End Enum


Public Enum Nag_MatrixType
  Nag_GeneralMatrix=1606
  Nag_LowerMatrix=1607
  Nag_UpperMatrix=1608
End Enum


Public Enum Nag_MeshSet
  Nag_DefInitMesh=1090
  Nag_UserInitMesh=1091
End Enum


Public Enum Nag_MeshType
  Nag_UniformMesh=1117
  Nag_CustomMesh=1118
End Enum


Public Enum Nag_ModeRNG
  Nag_InitializeReference=2160
  Nag_GenerateFromReference=2161
  Nag_InitializeAndGenerate=2162
  Nag_GenerateWithoutReference=2163
End Enum


Public Enum Nag_MomentType
  Nag_RatioMoments=1353
  Nag_LinearRatio=1354
  Nag_QuadRatio=1355
End Enum


Public Enum Nag_NearCorr_ProbType
  Nag_LowerBound=2810
  Nag_WeightedNorm=2811
  Nag_Both=2812
End Enum


Public Enum Nag_NodeStatus
  Nag_NS_NotSet=1590
  Nag_NS_NotSolved=1591
  Nag_NS_NotBranched=1592
  Nag_NS_long=1593
  Nag_NS_Bounded=1594
  Nag_NS_Infeasible=1595
  Nag_NS_Terminated=1596
End Enum


Public Enum Nag_Node_Selection
  Nag_NodSel_NotSet=1576
  Nag_Deep_Search=1577
  Nag_Broad_Search=1578
  Nag_MinObj_Search=1579
  Nag_DeepBroad_Search=1580
  Nag_DeepMinObj_Search=1581
End Enum


Public Enum Nag_NormType
  Nag_OneNorm=171
  Nag_TwoNorm=173
  Nag_FrobeniusNorm=174
  Nag_InfNorm=175
  Nag_MaxNorm=177
  Nag_RealMaxNorm=178
End Enum


Public Enum Nag_ODEMethod
  Nag_Adams=2750
  Nag_BDF=2751
End Enum


Public Enum Nag_ObserverForm
  Nag_UH_Observer=1551
  Nag_LH_Observer=1552
End Enum


Public Enum Nag_OptimOpt
  Nag_PWM=2660
  Nag_MOM=2661
  Nag_MOMMLE=2662
  Nag_PWMMLE=2663
End Enum


Public Enum Nag_OptionLOO
  Nag_WantLOO=2640
  Nag_NoLOO=2641
End Enum


Public Enum Nag_OptionType
  Nag_EuropeanCall=1113
  Nag_AmericanCall=1114
  Nag_EuropeanPut=1115
  Nag_AmericanPut=1116
End Enum


Public Enum Nag_OrderType
  Nag_RowMajor=101
  Nag_ColMajor=102
End Enum


Public Enum Nag_OsherVersion
  Nag_OsherOriginal=1122
  Nag_OsherPhysical=1123
End Enum


Public Enum Nag_OutputType
  Nag_OutputNotSet=1563
  Nag_NoOutput=1564
  Nag_MPS_Summary=1565
  Nag_MPS_List=1566
End Enum


Public Enum Nag_ParaEstimates
  Nag_ParaSupplied=1496
  Nag_ParaEstimated=1497
End Enum


Public Enum Nag_ParaOption
  Nag_NoPara=2630
  Nag_OrigPara=2631
  Nag_StandPara=2632
End Enum


Public Enum Nag_Parity
  Nag_Odd=1
  Nag_Even=2
End Enum


Public Enum Nag_Perturb
  Nag_PerturbOn=2800
  Nag_PerturbOff=2801
End Enum


Public Enum Nag_PopVar
  Nag_PopVarEqual=1473
  Nag_PopVarNotEqual=1474
End Enum


Public Enum Nag_PredictError
  Nag_BIC=2600
  Nag_FPE=2601
  Nag_LOOCV=2602
  Nag_EUV=2603
  Nag_GCV=2604
  Nag_UEV=2605
End Enum


Public Enum Nag_Preprocess
  Nag_ColpivRrank=2780
  Nag_ColpivRrankCond=2781
  Nag_FullpivRrank=2782
  Nag_FullpivRrankCond=2783
  Nag_ColpivSVrankAbs=2784
  Nag_ColpivSVrankRel=2785
End Enum


Public Enum Nag_PrinCompMat
  Nag_MatCorrelation=1393
  Nag_MatStandardised=1394
  Nag_MatSumSq=1395
  Nag_MatVarCovar=1396
End Enum


Public Enum Nag_PrinCompScores
  Nag_ScoresStand=1397
  Nag_ScoresNotStand=1398
  Nag_ScoresUnitVar=1399
  Nag_ScoresEigenval=1400
End Enum


Public Enum Nag_PrintType
  Nag_PrintNotSet=1124
  Nag_NoPrint=1125
  Nag_Soln_Root=1126
  Nag_Soln=1127
  Nag_Iter=1128
  Nag_Iter_Long=1129
  Nag_Soln_Root_Iter=1130
  Nag_Soln_Iter=1131
  Nag_Soln_Iter_Long=1132
  Nag_Soln_Iter_Const=1133
  Nag_Soln_Iter_Diag=1134
  Nag_Soln_Iter_Full=1135
End Enum


Public Enum Nag_PriorProbability
  Nag_EqualPrior=1428
  Nag_GroupSizePrior=1429
  Nag_UserPrior=1430
End Enum


Public Enum Nag_ProblemType
  Nag_ProbTypeNotSet=1187
  Nag_FP=1188
  Nag_LP=1189
  Nag_QP1=1190
  Nag_QP2=1191
  Nag_QP3=1192
  Nag_QP4=1193
  Nag_LS1=1194
  Nag_LS2=1195
  Nag_LS3=1196
  Nag_LS4=1197
  Nag_SparseFP=1198
  Nag_SparseLP=1199
  Nag_SparseQP=1200
  Nag_SparseFPE=1201
  Nag_SparseFPL=1202
  Nag_SparseFPS=1203
  Nag_SparseQPP=1204
  Nag_SparseQPS=1205
End Enum


Public Enum Nag_PsiFun
  Nag_PsiNotSet=1378
  Nag_Lsq=1379
  Nag_HuberFun=1380
  Nag_HampelFun=1381
  Nag_AndrewFun=1382
  Nag_TukeyFun=1383
End Enum


Public Enum Nag_QuadType
  Nag_Quad_Gauss_Legendre=2710
  Nag_Quad_Gauss_Jacobi=2710
  Nag_Quad_Gauss_Jacobi_Adjusted=2710
  Nag_Quad_Gauss_Exponential=2715
  Nag_Quad_Gauss_Exponential_Adjusted=2715
  Nag_Quad_Gauss_Laguerre=2713
  Nag_Quad_Gauss_Laguerre_Adjusted=2713
  Nag_Quad_Gauss_Hermite=2714
  Nag_Quad_Gauss_Hermite_Adjusted=2714
  Nag_Quad_Gauss_Rational=2715
  Nag_Quad_Gauss_Rational_Adjusted=2715
End Enum


Public Enum Nag_QuadWeight
  Nag_Alg=1072
  Nag_Alg_loga=1073
  Nag_Alg_logb=1074
  Nag_Alg_loga_logb=1075
End Enum


Public Enum Nag_QuasiRandom_Scrambling
  Nag_NoScrambling=2590
  Nag_OwenLike=2591
  Nag_FaureTezuka=2592
  Nag_OwenFaureTezuka=2593
End Enum


Public Enum Nag_QuasiRandom_Sequence
  Nag_QuasiRandom_Sobol=1624
  Nag_QuasiRandom_SobolA659=1627
  Nag_QuasiRandom_Nied=1626
End Enum


Public Enum Nag_RCIMethod
  Nag_RCI_Exact=1479
  Nag_RCI_Approx=1480
End Enum


Public Enum Nag_RCondType
  Nag_NotRCond=2050
  Nag_RCondEigVals=2051
  Nag_RCondLeft=2052
  Nag_RCondRight=2053
  Nag_RCondEigVecs=2053
  Nag_RCondBoth=2053
End Enum


Public Enum Nag_RFP_Store
  Nag_RFP_Normal=2700
  Nag_RFP_Trans=2701
  Nag_RFP_ConjTrans=2702
End Enum


Public Enum Nag_RK_method
  Nag_RK_2_3=1094
  Nag_RK_4_5=1095
  Nag_RK_7_8=1096
End Enum


Public Enum Nag_RangeStat
  Nag_UseRange=1543
  Nag_UseSD=1544
End Enum


Public Enum Nag_RangeType
  Nag_AllValues=1054
  Nag_Interval=1055
  Nag_Indices=1056
End Enum


Public Enum Nag_RegType
  Nag_RegNotSet=1374
  Nag_HuberReg=1375
  Nag_MallowsReg=1376
  Nag_SchweppeReg=1377
End Enum


Public Enum Nag_RegularizedType
  Nag_Regularized=2910
  Nag_NotRegularized=2911
End Enum


Public Enum Nag_RightVecsType
  Nag_RightVecs=2090
  Nag_NotRightVecs=2091
   Nag_RightVecsJRots=2092
  Nag_NotRightWork=2093
  Nag_RightVecsMV=2094
End Enum


Public Enum Nag_RotationLoading
  Nag_RoLoadStand=1405
  Nag_RoLoadNotStand=1406
End Enum


Public Enum Nag_RotationScale
  Nag_LsqScale=1413
  Nag_NotLsqScale=1414
End Enum


Public Enum Nag_ScaleCriterion
  Nag_Stress=1452
  Nag_SStress=1453
End Enum


Public Enum Nag_ScalePredictor
  Nag_PredNoScale=2620
  Nag_PredStdScale=2621
  Nag_PredUserScale=2622
End Enum


Public Enum Nag_ScaleResType
  Nag_ScaleRes=1601
  Nag_UnscaleRes=1602
End Enum


Public Enum Nag_ScaleType
  Nag_NoScale=1258
  Nag_NoScaleProvided=1262
  Nag_ScaleProvided=1261
  Nag_ScaleNotSet=1257
  Nag_RowColScale=1259
  Nag_ExtraScale=1260
End Enum


Public Enum Nag_Scores
  Nag_RankScores=1335
  Nag_NormalScores=1336
  Nag_BlomScores=1337
  Nag_TukeyScores=1338
  Nag_WaerdenScores=1339
  Nag_SavageScores=1340
End Enum


Public Enum Nag_SearchMatch
  Nag_First=1599
  Nag_Last=1600
End Enum


Public Enum Nag_SelectMoments
  Nag_CumulantsOnly=1351
  Nag_ComputeMoments=1352
End Enum


Public Enum Nag_Select_Eigenvalues
  Nag_Select_Modulus=1265
  Nag_Select_RealPart=1266
End Enum


Public Enum Nag_Series
  Nag_SeriesGeneral=0
  Nag_SeriesEven=1
  Nag_SeriesOdd=2
End Enum


Public Enum Nag_SideType
  Nag_LeftSide=141
  Nag_RightSide=142
  Nag_BothSides=143
End Enum


Public Enum Nag_SigmaEst
  Nag_SigmaNotSet=1384
  Nag_SigmaRes=1385
  Nag_SigmaConst=1386
  Nag_SigmaChi=1387
End Enum


Public Enum Nag_SigmaSimulEst
  Nag_SigmaSimul=1391
  Nag_SigmaBypas=1392
End Enum


Public Enum Nag_SignType
  Nag_Plus=1042
  Nag_Minus=1043
End Enum


Public Enum Nag_SignsType
  Nag_LowerMinus=3050
  Nag_UpperMinus=3051
End Enum


Public Enum Nag_SmoothFitType
  Nag_SmoothFitPartial=1507
  Nag_SmoothFitQuick=1508
  Nag_SmoothFitFull=1509
End Enum


Public Enum Nag_SmoothParamMethods
  Nag_SmoothParamCV=1510
  Nag_SmoothParamGCV=1511
  Nag_SmoothParamDF=1512
End Enum


Public Enum Nag_Smooth_Type
  Nag_4253H=1505
  Nag_3RSSH=1506
End Enum


Public Enum Nag_SolDeriv
  Nag_Sol=1099
  Nag_Der=1100
  Nag_SolDer=1101
End Enum


Public Enum Nag_SolveSystem
  Nag_LDLTX=1267
  Nag_LDX=1268
  Nag_DLTX=1269
  Nag_LLTX=1270
  Nag_LX=1271
  Nag_LTX=1272
End Enum


Public Enum Nag_SortEigValsType
  Nag_NoSortEigVals=2110
  Nag_SortEigVals=2111
End Enum


Public Enum Nag_SortOrder
  Nag_Ascending=1597
  Nag_Descending=1598
  Nag_Unsorted=500013
End Enum


Public Enum Nag_SparseNsym_CheckData
  Nag_SparseNsym_NoCheck=1314
  Nag_SparseNsym_Check=1315
End Enum


Public Enum Nag_SparseNsym_Dups
  Nag_SparseNsym_RemoveDups=1289
  Nag_SparseNsym_SumDups=1290
  Nag_SparseNsym_FailDups=1291
End Enum


Public Enum Nag_SparseNsym_Fact
  Nag_SparseNsym_ModFact=1279
  Nag_SparseNsym_UnModFact=1280
End Enum


Public Enum Nag_SparseNsym_Method
  Nag_SparseNsym_RGMRES=1273
  Nag_SparseNsym_CGS=1274
  Nag_SparseNsym_BiCGSTAB=1275
  Nag_SparseNsym_CG=1276
  Nag_SparseNsym_SYMMLQ=1277
  Nag_SparseNsym_TFQMR=1278
  Nag_SparseNsym_MINRES=1279
End Enum


Public Enum Nag_SparseNsym_Piv
  Nag_SparseNsym_NoPiv=1281
  Nag_SparseNsym_UserPiv=1282
  Nag_SparseNsym_PartialPiv=1283
  Nag_SparseNsym_CompletePiv=1284
  Nag_SparseNsym_MarkowitzPiv=1285
End Enum


Public Enum Nag_SparseNsym_PrecType
  Nag_SparseNsym_NoPrec=1299
  Nag_SparseNsym_SSORPrec=1300
  Nag_SparseNsym_JacPrec=1301
  Nag_SparseNsym_Prec=1302
End Enum


Public Enum Nag_SparseNsym_Store
  Nag_SparseNsym_StoreCS=1292
  Nag_SparseNsym_StoreSCS=1293
End Enum


Public Enum Nag_SparseNsym_Weight
  Nag_SparseNsym_Weighted=1303
  Nag_SparseNsym_UnWeighted=1304
End Enum


Public Enum Nag_SparseNsym_Zeros
  Nag_SparseNsym_RemoveZeros=1286
  Nag_SparseNsym_KeepZeros=1287
  Nag_SparseNsym_FailZeros=1288
End Enum


Public Enum Nag_SparseSym_Bisection
  Nag_SparseSym_Bisect=1307
  Nag_SparseSym_NoBisect=1308
End Enum


Public Enum Nag_SparseSym_CheckData
  Nag_SparseSym_NoCheck=1316
  Nag_SparseSym_Check=1317
End Enum


Public Enum Nag_SparseSym_Dups
  Nag_SparseSym_SumDups=1325
  Nag_SparseSym_RemoveDups=1326
End Enum


Public Enum Nag_SparseSym_Fact
  Nag_SparseSym_ModFact=1297
  Nag_SparseSym_UnModFact=1298
End Enum


Public Enum Nag_SparseSym_Method
  Nag_SparseSym_CG=1294
  Nag_SparseSym_Lanczos=1295
  Nag_SparseSym_TFQMR=1296
End Enum


Public Enum Nag_SparseSym_Piv
  Nag_SparseSym_NoPiv=1318
  Nag_SparseNsym_UserPiv=1319
  Nag_SparseNsym_PartialPiv=1320
  Nag_SparseNsym_CompletePiv=1321
  Nag_SparseNsym_MarkowitzPiv=1322
End Enum


Public Enum Nag_SparseSym_PrecType
  Nag_SparseSym_Prec=1321
  Nag_SparseSym_NoPrec=1322
  Nag_SparseSym_SSORPrec=1323
  Nag_SparseSym_JacPrec=1324
End Enum


Public Enum Nag_SparseSym_Weight
  Nag_SparseSym_Weighted=1305
  Nag_SparseSym_UnWeighted=1306
End Enum


Public Enum Nag_SparseSym_Zeros
  Nag_SparseSym_KeepZeros=1327
  Nag_SparseSym_RemoveZeros=1328
End Enum


Public Enum Nag_SplineVectorSort
  Nag_SplineVectorSort_Sorted=1
  Nag_SplineVectorSort_Sorted_Indexed=2
  Nag_SplineVectorSort_Sorted_Indexed_Perm=3
  Nag_SplineVectorSort_Unsorted=4
  Nag_SplineVectorSort_Unsorted_Indexed=5
End Enum


Public Enum Nag_Start
  Nag_StartNotSet=1106
  Nag_Cold=1107
  Nag_Warm=1108
  Nag_Hot=1109
  Nag_NewStart=1110
  Nag_ReStart=1111
  Nag_Continue=1112
  Nag_BasisFile=50001
End Enum


Public Enum Nag_SumSquare
  Nag_AboutMean=1362
  Nag_AboutZero=1363
End Enum


Public Enum Nag_TS_ChangeType
  Nag_NormalMean=2990
  Nag_NormalStd=2991
  Nag_NormalMeanStd=2992
  Nag_GammaScale=2993
  Nag_ExponentialLambda=2994
  Nag_PoissonLambda=2995
End Enum


Public Enum Nag_TS_Interpolation
  Nag_PreviousPoint=2850
  Nag_Linear=2851
  Nag_NextPoint=2852
End Enum


Public Enum Nag_TS_SegSide
  Nag_FirstSegCall=3000
  Nag_SecondSegCall=3001
  Nag_LeftSubSeg=3002
  Nag_RightSubSeg=3003
End Enum


Public Enum Nag_TS_Transform
  Nag_Identity=2860
  Nag_AbsVal=2861
  Nag_AbsDiff=2862
  Nag_AbsValScaled=2863
  Nag_AbsDiffScaled=2864
End Enum


Public Enum Nag_TS_URProbMethod
  Nag_ViaLookUp=3020
  Nag_ViaLookUpOriginal=3021
  Nag_ViaSimulation=3022
End Enum


Public Enum Nag_TS_URTestType
  Nag_UnitRoot=3020
  Nag_UnitRootWithDrift=3021
  Nag_UnitRootWithDriftAndTrend=3022
End Enum


Public Enum Nag_TableStats
  Nag_TableStatsNObs=1515
  Nag_TableStatsTotal=1516
  Nag_TableStatsAv=1517
  Nag_TableStatsMedian=1518
  Nag_TableStatsVar=1519
  Nag_TableStatsLarge=1520
  Nag_TableStatsSmall=1521
End Enum


Public Enum Nag_TableUpdate
  Nag_TableUpdateU=1522
  Nag_TableUpdateI=1523
End Enum


Public Enum Nag_TabulateVar
  Nag_TabulateVarDiscr=1524
  Nag_TabulateVarCont=1525
End Enum


Public Enum Nag_TailProbability
  Nag_LowerTail=1329
  Nag_UpperTail=1330
  Nag_TwoTailSignif=1331
  Nag_TwoTailConfid=1332
  Nag_Central=1334
  Nag_TwoTail=1333
End Enum


Public Enum Nag_TestStatistics
  Nag_DavidsAndMoodsTest=500032
  Nag_DavidsTest=500033
  Nag_MoodsTest=500034
End Enum


Public Enum Nag_Ties
  Nag_AverageTies=1341
  Nag_LowestTies=1342
  Nag_HighestTies=1343
  Nag_RandomTies=1344
  Nag_IgnoreTies=1345
End Enum


Public Enum Nag_TransNorm
  Nag_NoTransNorm=1407
  Nag_Orig=1408
  Nag_OrigCentroid=1409
  Nag_Norm=1410
  Nag_OrigNorm=1411
  Nag_OrigNormCentroid=1412
End Enum


Public Enum Nag_TransType
  Nag_NoTrans=111
  Nag_Trans=112
  Nag_ConjTrans=113
End Enum


Public Enum Nag_TransformDirection
  Nag_ForwardTransform=1070
  Nag_BackwardTransform=1071
End Enum


Public Enum Nag_TrigTransform
  Nag_Cosine=1079
  Nag_Sine=1080
End Enum


Public Enum Nag_UpdateObserv
  Nag_ObservAdd=1360
  Nag_ObservDel=1361
End Enum


Public Enum Nag_UploType
  Nag_Upper=121
  Nag_Lower=122
End Enum


Public Enum Nag_VIFOption
  Nag_NoVIF=2650
  Nag_WantVIF=2651
End Enum


Public Enum Nag_VarCovar
  Nag_GroupCovar=2920
  Nag_PooledCovar=2921
  Nag_GroupVar=2922
  Nag_PooledVar=2923
  Nag_OverallVar=2924
End Enum


Public Enum Nag_VarScaleType
  Nag_VarScaleStd=1436
  Nag_VarScaleRange=1437
  Nag_VarScaleUser=1438
  Nag_NoVarScale=1439
End Enum


Public Enum Nag_Var_Selection
  Nag_VarSel_NotSet=1582
  Nag_First_Int=1583
  Nag_Nearest_Half=1584
  Nag_Use_Priority=1585
End Enum


Public Enum Nag_VariableType
  Nag_Real=2740
  Nag_long=2741
  Nag_Character=2742
  Nag_long_Additional=2743
  Nag_Real_Additional=2744
End Enum


Public Enum Nag_Variogram
  Nag_VgmSymmStab=1
  Nag_VgmCauchy=2
  Nag_VgmDifferential=3
  Nag_VgmExponential=4
  Nag_VgmGauss=5
  Nag_VgmNugget=6
  Nag_VgmSpherical=7
  Nag_VgmBessel=8
  Nag_VgmHole=9
  Nag_VgmWhittleMatern=10
  Nag_VgmContParam=11
  Nag_VgmGenHyp=12
  Nag_VgmCosine=13
  Nag_VgmBrownian=14
End Enum


Public Enum Nag_VectType
  Nag_FormBoth=1057
  Nag_DoNotForm=1058
  Nag_ApplyP=1060
  Nag_FormP=1059
  Nag_FormX=1064
  Nag_ApplyQ=1062
  Nag_FormQ=1061
  Nag_UpdateQ=1063
End Enum


Public Enum Nag_VectorOp
  Nag_Convolution=1068
  Nag_Correlation=1069
End Enum


Public Enum Nag_Wavelet
  Nag_Morlet=2240
  Nag_DGauss=2241
  Nag_MexHat=2242
  Nag_Haar=2243
  Nag_Daubechies2=2244
  Nag_Daubechies3=2245
  Nag_Daubechies4=2246
  Nag_Daubechies5=2247
  Nag_Daubechies6=2248
  Nag_Daubechies7=2249
  Nag_Daubechies8=2250
  Nag_Daubechies9=2251
  Nag_Daubechies10=2252
  Nag_Biorthogonal1_1=2253
  Nag_Biorthogonal1_3=2254
  Nag_Biorthogonal1_5=2255
  Nag_Biorthogonal2_2=2256
  Nag_Biorthogonal2_4=2257
  Nag_Biorthogonal2_6=2258
  Nag_Biorthogonal2_8=2259
  Nag_Biorthogonal3_1=2260
  Nag_Biorthogonal3_3=2261
  Nag_Biorthogonal3_5=2262
  Nag_Biorthogonal3_7=2263
End Enum


Public Enum Nag_WaveletCoefficients
  Nag_StoreFinal=2570
  Nag_StoreAll=2571
End Enum


Public Enum Nag_WaveletMode
  Nag_HalfPointSymmetric=2220
  Nag_WholePointSymmetric=2221
  Nag_Periodic=2222
  Nag_ZeroPadded=2223
End Enum


Public Enum Nag_WaveletTransform
  Nag_SingleLevel=2560
  Nag_MultiLevel=2561
  Nag_MODWTSingle=2562
  Nag_MODWTMulti=2563
End Enum


Public Enum Nag_WeightMode
  Nag_InitWeights=2770
  Nag_ReuseWeights=2771
End Enum


Public Enum Nag_Weightstype
  Nag_NoWeights=1401
  Nag_Weights=1402
  Nag_Weightsfreq=1403
  Nag_Weightsvar=1404
End Enum


Public Enum Nag_WindowType
  Nag_WindowSupplied=2900
  Nag_RuleOfThumb=2901
End Enum


Public Enum Nag_ZeroCols
  Nag_ZeroColsNormal=2790
  Nag_ZeroColsRestrict=2791
End Enum


Public Enum Nag_ab_input
  Nag_ab_prod=1549
  Nag_ab_sep=1550
End Enum



' end enumeration types


' delegate declarations



